	CHANGES from fml 0.x(1993) to fml-current

				深町 賢一

最新の動向については INFO というファイルを見て下さい。
このファイルは作者による変更点のメモです。
contributor およびその変更点については RELEASE_NOTES を見て下さい。

2001/06/02

   4.0.1_BETA2

   doc/html/booknotes.ja.html (2.4-2.5):
   doc/Japanese/RDBMS/postgresql.wix (1.4-1.5): 
	caution: seems not work with postgresql 7.1.x ;)

2001/05/25

   module/fml-devel/Mail/Delivery/
	bug fix IPv6 error handling

	IPv6 エラーコードのバグ修正

2001/05/20

   sbin/makefml

	CGI で: htpasswd のデフォルト permission をユーザ nobody でも
		見えるように修正する。
		＃いいのか？それで、という気もするのだが…

2001/05/11

   IPv6 by default

	常に IPv6 でメールサーバに接続することに挑戦してみる。
	もし、失敗したら IPv4 で挑戦する。
	これがデフォルト

	$USE_INET6 を 0 にすると IPv4 オンリーに戻ります。

2001/05/10

   kern/libsmtp.pl
	enable IPv6

	IPv6 を有効にする(fml 5.0 の IPv6 モジュールを使っている)。

   messages/Japanese/amctl (1.5-1.6):
	fix Japanese to be more friendly for newbies

2001/05/03

   sbin/makefml (2.210-2.211):
	fix mladmin.cgi help typo

2001/04/27

   module/Japanese/liblangdep.pl (1.7-1.8): 
	remove Re> pattern in subject

   proc/libamctl.pl (2.47-2.48):
	correct subscribe keyword in warning

   kern/libkernsubr2.pl (2.5-2.6):
	add List-ID

2001/04/17

   www/lib/libcgi_makefml.pl (1.59-1.60):
	more friendly error message

2001/04/11

   sys/SOLARIS2/depend.pl (1.2-1.3):
	mkdir $DIR/var/run if not exists for lock

   databases/postgresql/DBI_toymodel.pl (1.3-1.4):
	nuke MySQL string

2001/04/05

   solaris 上でのロックのバグの修正

2001/04/02

   proc/libamctl.pl
	bug fix "amctl.info" message

2001/03/25

   cf/MANIFEST 
	ML_FN = null by default

2001/03/23

   proc/libamctl.pl
	apply patch by shigetoshi hirano (fml-support: 09336)
	check the member who subscribes this list is duplicated or not

2001/03/15

   proc/libexpire.pl
	$*_seq initialization bug of expiration by number
   	patch by Tatsuya Shimizu <shimizu@np.bs1.fc.nec.co.jp>
	fml-help: 00039

2001/03/09

    コマンドの返事をする時に、
    もし $LANGUAGE eq 'Japanese' ならいつも

	Mime-Version: 1.0
	Content-Type: text/plain; charset=iso-2022-jp

	＃ちょっとうそっぽい…      

2001/03/07

  define $SMTP_LOG_ROTATE_EXPIRE_LIMIT 
	90 days by default

	$SMTP_LOG_ROTATE_TYPE が day の時に、この
	$SMTP_LOG_ROTATE_EXPIRE_LIMIT を指定すると
	古い _smtplog.日付 ファイルを消す。
	デフォルトは 90 日以上古いファイル。

2001/03/04

  lowerize the domain part of mail addresses in database access methods 

2001/02/26

  apply patch (fml-support: 09289) to the PostgreSQL toymodel 
	thanks shigetoshi hirano <s_hirano@eva.hi-ho.ne.jp>

2001/02/18

   fix perl search path algorithm
	thanks Yu Ooasa <you@dearest.net> (fml-support: 09276, 09277)

   fix NT 4.0
	link($SMTP_LOG, $org_smtp_log) only on unix
	thanks Kozo Sasaki <ssk@pse.pfu.co.jp> (fml-support: 09271)

   fix NT installer bugs
	install also ("databases", "messages", "drafts", "module")
	thanks Kozo Sasaki <ssk@pse.pfu.co.jp> (fml-support: 09235)

2001/02/07,08

   update documents

2001/02/06

   fml/libexec/fmlserv.pl 
	s/RunHooks/RunExitHooks/ to fix missing renamed function definition
	thanks KAWADE Koji <kawade@rd.casio.co.jp> (fml-support: 09238)

2001/02/03

  fmlserv
	oops, RunHooks() is not used now.
	fix it to use RunexitHooks().

2001/02/01

  ドキュメント修正
	オライリー本への補足、誤植等について…
	welcome ファイルを送り返さない方法
	DEFINE_MODE(disablenotify) について補足

   makefml
	fix _PERL_PATH handling

	env _PERL_PATH= makefml ...
	の指定をする時も perl をさがしてしまうバグをなおす

2001/01/22

   4.0-stable series start

   apply patch to html converter (fml-support:09166) 
	not to ignore forwarded messages

	KUBO Hiroya <hiroya@netcom.mag.keio.ac.jp>

2001/01/15
   4.0 release

2001/01/10

   doc/Japanese/examples/virus_check.ph
	add rules against win32/mtx

2000/12/29

   makefml html_config
	fix null value check

2000/12/28

   makefml
	nuke undefined ERROR()

2000/12/24

	CGI fix the behaviour in /ml-admin/$ml layer

		/ml-admin/$ml/ 階層の修正

2000/12/22

	htpasswd 関連の表示を修正

2000/12/17

   CGI
	fix charset of META 
	EUC'fy

2000/12/13

   /bin/fwix.pl 
	add pointer (to previous, to next) in the top of each page.
	nuke too many <PRE></PRE> magic code

2000/12/11 --

	clean up, fix, update documents, documents, documents, ...
		....
			....

2000/12/10

   4.0_BETA

2000/12/09

   translate CGI menu to English

   review CGI codes
	more strict variable checks

	変数の表現空間をよりきびしいチェックする

2000/12/06

   prepare doc/English/ 
	imported it anyway

2000/12/04

   proc/libsynchtml.pl
	apply patch by fml-support:8935
		 ( Tomoki Ichinoseki <ichinskt@synap.co.jp> )

2000/12/03

   help file
	apply patch by <kazuto@Kz-soft.com> (fml-support: 09081)

	help ファイルに MH フォルダの場合の復元のし方
	についてのメモを付け加える

   databases/postgresql/DBI_toymodel.pl
	PostgreSQL DBI version

	This library is based on the patch ( fml-support: 09069 ) by
	Toshimi Aoki.

   sbin/makefml
	fix 12/02 bug fixes more.

2000/12/02

   sbin/makefml
	preserver inode permission in manipulate *passwd.
	modify lockfile only if virtual ml is 'etc' (that is
	/var/spool/ml/etc).

2000/11/30

   clean up cgi around (clean up for 4.0 release ...)
	clean up 
	modify temorary buffer allocation code

2000/11/28

   kern/Makefile
	remove not used environmental variables

2000/11/17

   kern/fml.pl
   module/CPAN/
	modify conv2mailbox() to use Mail::Address module for more
	correctness. apply patches in
	fml-support: 09026, 09027 by OGAWA Kunihiko <kuni@edit.ne.jp>

  fix internal to make fml/ml-admin/ ... hier

2000/11/07

   drafts/English/
	fix language over these templates

2000/11/06

   makefml
	consider ? + / in the mailing list address

2000/10/30

  makefml
	fix to map pgp2 => aa.pgp2 by default

  fix pgp around
	fml/proc: libdist.pl libpgp.pl libra.pl 
	fix to follow $ENCRYPTED_DISTRIBUTION_TYPE and
	$REMOTE_ADMINISTRATION_AUTH_TYPE

  fix messages for moderators in each mode (article/command)
	PR fml-support:8849   

2000/10/29

  4.0_ALPHA starts

	ftp://ftp.fml.org/pub/fml/current/

2000/10/28

  nuke some libraries in proc/ since these are not maintained long time.

	最近メインテンナスされてない２、３のライブラリを削除
		proc/libftpmail.pl
		proc/libftp.pl
		proc/libhref.pl

  makefml ml-admin.cgi $ml {update,config}

2000/10/15

   make install RECOMMEND=yes
	installs cf.recommneded

	make install RECOMMEND=yes
	もしくは
	env RECOMMEND=yes perl makefml install

	インストール時に推奨設定の cf を準備する。
	＃つまり make secure した時にできる cf の原型

2000/10/14

   fmlwrapper.c (nuke fml.c) and fmlwrapper is used now
	since the names of fml and fml-ctl are ambiguous.

	config.h is removed but now fmlwrapper.h is used.

2000/10/11

   makefml	set umask(022) when &CollectAlaises() runs.

2000/10/10

   mead		a lot of hacks

2000/10/05

   proc/libra.pl
	define "admin add2actives" "admin add2members"

		admin add2actives
		admin add2members
		admin addactives
		admin addmembers

	という片方のファイルにだけ登録する admin コマンド

   proc/libfml.pl
	nuke debug code

	ごめんなさい MAXLEN_COMMAND_INPUT のデバッグコード抜き忘れてました
	current の 20001004 は使わないで下さい。

2000/10/04

   proc/libfml.pl
	define MAXLEN_COMMAND_INPUT
	The maximum length for each command. 128 bytes by default.

   kern/fml
	add mead as a loop check target.
	LoopBackWarn(): check mead@$DOMAINNAME against mail loop

   makefml mead
	set up /var/spool/ml/mead for mead working directory

   add "makefml recollect-aliases"
	% cat /var/spool/ml/*/aliases > /var/spool/ml/etc/aliases
	based on "UENO Kazuaki" <kazu@a-u.net> (fml-support: 08834)

	/var/spool/ml/etc/aliases を再生成するコマンド

   var/log/_smtplog.$i
	always log SMTP between fml and MTA to var/log/_smtplog.$i
	where $i is 0 .. 7 (modulo 8).
	This is default configuration now for 4.0 release.
	Configuration:
	$USE_SMTP_LOG_ROTATE toggle flag (defualt 1)
	$NUM_SMTP_LOG_ROTATE modulo, the number of files (default 8)

	つねに _smtplog.数字 のログを残すようにしました。
	でもディスクをくうのでデフォルトは 8 です。

2000/10/01

  mead.pl
	pickup information from smtpfeed -F -1 case

	smtpfeed -1 -F の時のエラーメールから情報を拾いだし
	error_addr.hinsts
	におく。これでフォワードのフォワードの先のエラーを
	追跡する。

  confirmd_master.sh	
	newly added

2000/09/27

   nuke <LIMIT> in .htaccess

2000/09/26

   import Jcode.pm 0.60 to cvs tree

2000/09/24

   fix include-outgoin template permission and other problems
	PR fml-support:8830 by UENO Kazuaki

   bin/daily_master.sh is added

2000/09/23

   makefml resend
	bug fix

   admin get
	controlled under @REMOTE_INACCESSIBLE_FILES

	でもこんな変数名でいいのかなぁ 

2000/09/19

   define IncrementCounter()
   define $USE_SMTP_LOG_ROTATE $NUM_SMTP_LOG_ROTATE

2000/09/12

   fix cf/config which should be read .fml/system if exists
	(PR fml-support: 08636 by Masayuki FUKUI)

   fix NT installer

	Windows 2000/NT でのインストーラの不具合をなおす
		エラーをつぶす
		perl path がうまくかわらないのをなおす

2000/09/10

   ADD_FIELD() always convert the args to be capitalized

	ADD_FIELD はどんな引数を与えても常に capital に変更する。
	XXX 変更していいのか？	

	例: ADD_FIELD('x-uja')  は ADD_FIELD('X-Uja') と解釈される。

   libdist.pl
   $USE_SMTPFEED_F_OPTION

	100 回に一回 smtpfeed -F -1 を使う。
	(smtpfeed の設定は各自がんばて下さい:)

	mead はこのヘッダを見ているが…

   makefml lock extension
	you can use "makefml lock -e script" now.

	makefml lock -e script を実行するとロックをかけつつ
	script を実行する。

2000/09/03

   sbin/makefml   
	define "skip" as an alias of "off" command

	makefml skip コマンドを makefml off と同じ意味にしました

2000/08/25

   sbin/makefml
	fix not to make /var/spool/ml/.crc
	fix flock on solaris2 

2000/08/24

   EnvelopeFilter
	enable EnvelopeFilter to filter Japenese strings.
	define EUCCompare(buf, pat) to check buf with the 2 bytes alignment.

	フィルタルールに日本語をかけるようにする。

2000/08/22

   fix "admin put" removes (^admin|^# admin) lines
	fml-support:8435

2000/08/21
   update virus_check.ph

	reject "filename=.*search.*URL.*\.exe" case

2000/08/20

   define utility functions used in config.ph:
	PERMIT_ADMIN_PROCEDURE()
	DENY_ADMIN_PROCEDURE()
	DEFINE_ADMIN_PROCEDURE()

2000/08/16

  3.0I rename KEYRING_PATH to KEYRING_DIR

	DIST_AUTH_KEYRING_DIR:		$DIR/etc/dist-auth
	DIST_ENCRYPT_KEYRING_DIR:	$DIR/etc/dist-encrypt
	ADMIN_AUTH_KEYRING_DIR:		$DIR/etc/admin-auth
	ADMIN_ENCRYPT_KEYRING_DIR:	$DIR/etc/admin-encrypt

2000/08/12

   3.0I	incompatible changes of authentication method by
		PGP2 PGP5

	PGP 回りの変更をしたために PGP 認証などが非互換になります。

	1. /var/spool/ml/etc/fml/site_force.ph に

		$DIST_ENCRYPT_KEYRING_DIR = $PGP_PATH;
		$ADMIN_AUTH_KEYRING_DIR   = $PGP_PATH;

	   と書くと、3.0H までと同じになります。

	2. もっと後向きな or 危ない解決方法として

		% cd /var/spool/ml/elena/etc
		% ln -s pgp dist-encrypt
		% ln -s pgp admin-auth

	    でも 3.0H までと同じことになります。

   "makefml help" show shelp by $ENV{'PAGER'} if defined.

   $PGP_VERSION is removed

2000/08/11

   update doc/Japanese/examples/virus_check.sh
	reject Pretty*Park*exe pattern
	for example "Pretty Park 1.exe" 

   change PGP related codes 
	XXX THIS CHANGE IS INCOMPATIBLE WITH fml 3.0 !!!

2000/08/09

   define new path's to enhance PGP2, PGP5 

	DIST_AUTH_KEYRING_PATH:		$DIR/etc/dist-auth
	DIST_ENCRYPT_KEYRING_PATH:	$DIR/etc/dist-encrypt
	ADMIN_AUTH_KEYRING_PATH:	$DIR/etc/admin-auth
	ADMIN_ENCRYPT_KEYRING_PATH:	$DIR/etc/admin-encrypt

2000/08/06

   messages
	modify search order

	/var/spool/ml/elena/messages.Japanese.conf  (<- newly added)
	/var/spool/ml/elena/messages.conf
	/var/spool/ml/elena/messages/Japanese/$file
	/var/spool/ml/etc/fml/messages/Japanese/$file
	/usr/local/fml/messages/Japanese/$file

2000/08/05

   messages
	modify search order

	エラーメッセージなどのカスタマイズをするファイルの
	サーチ順を変えました。elena MLの場合は

	/var/spool/ml/elena/messages.conf
	/var/spool/ml/elena/messages/Japanese/$file
	/var/spool/ml/etc/fml/messages/Japanese/$file
	/usr/local/fml/messages/Japanese/$file

	$file はいろいろです。kern, auth , ...
	それぞれのファイルの意味は

	/usr/local/fml/messages/Japanese/MANIFEST.Japanese
	http://www.fml.org/fml/messages-list.ja.txt

	を見て下さい。デフォルトでは

	/usr/local/fml/messages/Japanese/$file

	にしかファイルはないので、ここのファイルが使われます。

2000/07/29

   check address more severely
	automatic subscribe
	mead.pl

2000/07/28

   add & enable members/actives commands for databases

	ごめん、データベース使う時の members actives コマンド
	書きかけのままだったので、書きました。

2000/07/27

   modify DELETE_FIELD() accepts case-insensitive argument

   nuke MySQL debug code ;)

2000/07/25

   kern/libloadconfig.pl
	define DUMMY,TRUE,FALSE for convenience

2000/07/24

   makefml
	nuke obsolete ConcatenateAliases()

   fix installer to disable installing C/*		

   modify EnvelopeFilter
	EnvelopeFilter should not count up the trailing "\n"
	to determine the number of paragraphs (signature or not).

2000/07/23

  Content Filter bug fix (?)
	appy patch by Naoki IDO (fml-support: 8504)

2000/07/21

  clean up databases
	add PostgreSQL and MySQL example

	PostgreSQL と MySQL のおもちゃモデルの例を追加しました。

2000/07/20

   nuke C/ since it is obsolete. 

   databases/ in distribution (new)
	clean up under this.

   kern/libloadconfig.pl
	apply patch from Naoki IDO (fml-support: 08476)
	resolve undefined bug in $debug on

   3.0H
	enable distribute via recipients list from database

	データベースから引いた配送リストを有効にする
	(3.0G ではデータベースアクセスのみで配送時に有効にはなっていなかった)

   kern/fml.pl databases/ldap/examples/libldap.pl proc/libdatabases.pl
	clarify variable convention between database functions

2000/07/19

   sys/WINDOWS_NT4/makefml.cmd
	enable to boot by hit "makefml" icon 

2000/07/18

   fix CGI profile: fml/sbin/makefml, fml/proc/libmesgle.pl 

	define MesgLE::CacheOn() in libmesgle
	and modify makefml Japanese convertor in html mode which calls
	translators too much !
	makefml in html mode uses this CacheOn() like this
		&MesgLE::CacheOn(*LangExtCache, $msgfile, 'euc');
	If %LangExtCache is non null, convertor uses this cache not look up
	this file. This cache accellerate 3 or 4 times faster conversion.

   check sum to validate relation between cf and config.ph
	(algorithm used by traditional AT&T UNIX)
	sbin/makefml
	bin/cksum.pl

   etc/makefml/Makefile
	use 'makefml update-config'

2000/07/17

   installation
	install makefml not makefml*

   sbin/makefml
	fix to use $^X not "perl" 

   sbin/makefml, cf/config, www/lib/lib*pl, module/*
	fix all perl path within scripts (polite for diag check?)
	from Naoki IDO <ido@hitachi-ms.co.jp> (fml-support: 08471)

2000/07/16

  fix installation on windows 2000 (2000 only???)
	sbin/makefml
		not use pwd but cd
		check USERNAME not $<, $> (this check is valid?)

  fix installation on windows NT4 (NT4 only?)
	sys/WINDOWS_NT4/ntinstall.cmd
		not use fix_syscalls.pl

	sys/WINDOWS_NT4/ntinstall.pl
		clean up installation messages
		nuke debug messages almost anywhere

2000/07/15

  sbin/makefml
  www/lib/libcgi_makefml.pl
	apply patch to fix collection of /var/spool/ml/etc/aliases
	from Naoki IDO <ido@hitachi-ms.co.jp> (fml-support: 08422, 08423)

2000/07/12

  apply patch to fix "makefml config-template" clean up code
	From Naoki IDO <ido@hitachi-ms.co.jp> (fml-support: 08410)

2000/07/09

   kern/fml.pl 
	rename &RunHooks() &RunExitHooks()
	define &RunEndHooks() for symmetric x

   proc/libdist.pl 
	arrange $DISTRIBUTE_START_HOOK and $DISTRIBUTE_END_HOOK in
	the beginning and end of &DoDistribute().
	$DISTRIBUTE_END_HOOK includes $SMTP_CLOSE_HOOK $DISTRIBUTE_CLOSE_HOOK

   MIME functions
	clean up debug codes, add function definitions:
		DecodeMimeStrings()
		DecodeMimeString()
		MimeEncode()
		MimeDecode()
		MIMEEncode()
		MIMEDecode()

2000/07/08

  3.0G  add database access hook
	define initial database access method
	enabel access via LDAP (Leightweight Directory Access Protocol)

  fix cgi-bin/ml-admin/menu.cgi

2000/07/05

  clean up internal for database access
	nuke CheckMember() to replace it with Lookup() or MailList*P()

2000/07/04

  more HOOK's
	add $PROCEDURE_CONFIG_HOOK and $ADMIN_PROCEDURE_CONFIG_HOOK to
	control %Procedure and %AdminProcedure after they are all
	initialized. 

2000/06/30

  bin/archive.sh
	clean up to enable to
	execute archive.pl automatically over all ML's under /var/spool/ml 

2000/06/29

  change the locatoin for message template files
	/usr/local/fml/drafts/Japanese/{help,guide,...}
	/usr/local/fml/drafts/English/{help,guide,...}

	テンプレートファイルの置き場所変えました。
	これで doc/ 以外に .jp シンタックスは消えた	

2000/06/25

  sbin/makefml
	make /usr/local/fml/.fml/system.sh in install
	for shell script

2000/06/20

	nuke sgets(), ipc()

2000/06/19

  sbin/makefml (on Windows NT4)
	fix behaviour around rename()

	config.ph を作り損ねた時のエラーハンドリングの間違いをなおす
	＃いわゆる NT の rename(2) まわり問題

  kern/fml.pl
	(back import a fix from 3.0.1_BETA #18)
	disable to reject "From: $MAIL_LIST" mail in default

	3.0-stable と同期してない部分を current へ逆輸入;)

        デフォルトでは From: $MAIL_LIST を弾かないように変更
        3.0ではループチェックの一部としてこれをしているが
        企業のサポート ML などではまるのでとりあえず戻す

	pointed out by MURASHITA Takuya (fml-support: 08220)

2000/06/17

   proc/libmodeutils.pl
   proc/libtagdef.pl 
	apply patch (fml-support: 08232) from HYOUDOH Kouichi <sio-0@rh.to>
	fix the regexp matching against too short string folding for subject

2000/06/16

  3.0F
	internal variable/function name changes (part 2)

	内部利用の関数や変数名の naming convention を修正しています(part II)
	もしなんか挙動がおかしいようなら bug-report をお願いします _o_

2000/06/13

  3.0E
	internal variable/function name changes

	内部利用の関数や変数名の naming convention を修正しています
	もしなんか挙動がおかしいようなら bug-report をお願いします _o_

2000/06/11

  bin/daily.pl
	if -f pattern_file is not defined, use $EXEC_DIR/etc/daily.ignore

2000/06/09

  CGI	contorable over all menu's

	従来メニューの一部は動かなかった。例えば
	SUBJECT_TAG_TYPE がセキュリティチェックのため動かなかったのを
	動くようにした。

2000/06/08

  EnvelopeFilter
	analyze based on paragraph map (pmap)

2000/06/07

  makefml
	modify initialize process to check $EXEC_DIR more but ...

  etc/makefml/menu.conf
  cf/MANIFEST
	MENU -> SECURITY_AND_FILTER -> PGP_VERSION -> 2 or 5

2000/06/05

  Mesg() Translation M/N ....

	fml の返すメッセージの整理整頓は続くよどこまでも… 
	＃力業はつらし(涙)

2000/06/03

  libpop.pl: change queue file name format

2000/06/02

  enable installer to search pgp5 programs
	See fml/cf/MANIFEST

	XXX PGP5 not yet support "admin pgp5 ... "

2000/06/01

  enhance PGP code to support PGP 2 and 5
  enables makefml {pgpv,pgpk,pgps,pgpe}
	libpgp.pl
	makefml

	まだ prototype (もぉちょっと待って)

	チャレンジャーもとむ！
	PGP 5 でちゃんと使えるかどうかをだれか確認してほしいす

	makefml のコマンドは
		PGP2	pgp
		PGP5	pgpk, pgps, pgpv, pgpe

	で使い分けて下さい。

  rename programs: archive.pl archive.sh with Archive.pl Archive.sh 
	so remove Archive.pl Archive.sh 

2000/05/31

  pgp2 code
	more debug 
	modify function/variable names to be easy for eyes

  doc/
	clean up to clarify apache-ssl and apache+mod_ssl

  messages/
	fix search miss (relation between filename and key)

  messages/English/ 
	create the directory and translates all templates (anyway ;-)

	勢いで全部英訳しました(へろへろ〜）

2000/05/29

  www/examples/postfix/main.cf
	no! use alias_maps not alias_database

2000/05/24

  libarchive.pl: fix function import bug (Thanks Yasuyuki Nakasone)

  add toggle menu for configuration menu on CUI and GUI.
	Please see "makefml config"
	   MAIN_MENU => OPTION => VARIABLE_OFF_ON => ...

	ある変数を off/on のどちらかにする( 1 or 0)くらいは
	全部メニューでできるようにしてみたです。

	   メニュー => OPTION => VARIABLE_OFF_ON => *1 => 変数名リスト => y/n

	*1 画面からはみ出るのをふせぐために変数名をソートして、
	   さらにアルファベット順の前半、後半で分けています。
	   前半は ^A .. ^K, 後半は ^L .. ^Z と画面に説明が出ています

  update INSTALL_on_NT4
	IMail "program aliases" works on NT4

	NT4 での話: IMail Server gold のプログラムエイリアスって 
	program つまり fml を起動してくれるんですね。えらいぞ

2000/05/23

  sbin/makefml 
	define 'tail' as an alises of 'log' command 
	Example:

	makefml elena::tail 

	は tail -10 と同じです

	makefml elena::tail -10

2000/05/22

  sbin/makefml
	clean up 'makefml log' code not to use system commands

2000/05/21

  cf/MANIFEST
	add missing definition
	+FILTER_ATTR_REJECT_NULL_BODY:      	1
	+FILTER_ATTR_REJECT_INVALID_COMMAND:    1
	+FILTER_ATTR_REJECT_ONE_LINE_BODY:     	1

2000/05/12

  sbin/makefml
	clean up (nuke) a lot of debug messages

	うざったいデバッグメッセージ類を一気に整理した
	(すっきりしすぎでしょうか？)

  FNF rewriting project starts ...
	See fml/FNF (in cvs repository)

  more checks on file operations
	define DiagPrograms( @ARRAY ) to check existence of programs and
	validate how command works.
	XXX TODO: file operations
	XXX   need further checks but logs errors in $DIR/log now anyway.

2000/05/11

  sbin/makefml
	disable info in makefml -w (runs on NT) mode

2000/05/10

  doc/Japanese/examples/virus_check.ph is added

	virus check の設定見本例
	(site_force.ph などにつかうといいだろうとおもう)

  bin/spool2html.pl (2.16-2.17):
	mkdir htdocs/ by 0755 explicitly

	spool2html をつかってはじめて htdocs/ をつくると
	700 でディレクトリができてしまうのを 755 に修正

2000/05/09

  kern/fml.pl 
	fml-support: 07764 by OGAWA Kunihiko <kuni@edit.ne.jp>
	fix RuleSetTo() rewriting

  messages/Japanese/confirm (1.1-1.2):
  proc/libconfirm.pl (2.18-2.19):
	add message in manual_subscribe mode which message describes
	how to confirm and subscribe 

	manual subscribe モードでも confirm が返るのだが
	この時は $DIR/confirm が返らない。
	書いてある内容が若干違うのでそのまま使うのには無理がある。

	messages/Japanese/confirm に新しく定義を加え
	短いながらその辺の説明をする文章を返るようにした。

  CGI interface: clean up to be easy for your eyes

2000/05/08

   makefml update ML config.ph : re-create ML's config.ph

	make config.ph と同じ効果をもつ

	% makefml update elena config.ph
		と
	% (cd /var/spool/ml/elena; make config.ph) 

	は同じことをする。ちなみに

	% makefml update-config.ph elena
	% makefml elena::update-config.ph

	はこれの alias である。

   makefml add2actives ML address
   makefml add2members ML address

	片方のファイルだけに(非対象に)登録するためのコマンド
	一応 2 が打ちにくいのでなくてもOKにしてある。

		makefml addactives
		makefml add2actives

	は一緒の意味

		makefml addmembers
		makefml add2members

	は一緒の意味

2000/05/05

   FA2000_003: advisory on Love Letter Worm

2000/05/03

   cf/MANIFEST
	prototype for email-address form should be null for 
	default_config.ph template.

	default_config.ph で $MAIL_LIST, $CONTROL_ADDRESS, $MAINTAINER
	のアドレスの template がNULLになるように設定を変更 	

2000/04/30

   $LOGFILE_SUFFIX	(default NULL)
	$LOGFILE_SUFFIX = ".%C%y";

	log ファイルにsuffixをつけられる。backup が楽
	例: log.2000

	See strftime(3) on the string to be used

   mead 
	clean up a little
	load /var/spool/ml/etc/mead/mead_config.ph if exists
	define $OVERWRITE_COMMAND_LINE_OPTIONS

	もし /var/spool/ml/etc/mead/mead_config.ph があれば
	その設定ファイルをロードする。もし
	$OVERWRITE_COMMAND_LINE_OPTIONS というオプションが
	あれば、mead のコマンドラインオプションよりこのファイルが
	優先される。

   etc/makefml/include-mead
	remove -m $mode

	mead の変更に伴い include-mead 見本ファイルから -m を削除

2000/04/29

   new tutororial documents

2000/04/27

   bump up to 3.0D (_cf changes for command line options)

   clean up campaign (modify global variable name)
   s/_cf/Opt/g over sentences for command line options
	bin/cron.pl
	kern/fml.pl
	kern/msend.pl
	proc/libfml.pl
	bin/split_and_msend.pl

   fix version numbering in sources and packages (fml-stable) 

   new functions used in config.ph (kern/libloadconfig.pl)
	add DEFINE_PROCEDURE()

2000/04/26

   new functions used in config.ph
	PERMIT_PROCEDURE()
	DENY_PROCEDURE()

   anonymous cvs server ready

	anonoymous 用のCVS準備できた。

2000/04/25

   bin/anoncvs is added. It is a wrapper script to access anoncvs.fml.org

	anonymous cvs サーバ用のscript 

2000/04/21

  cut off Re: Re: Re:
	modify regexp to avoid compilation error (related to perl version) 

2000/04/15

  sbin/makefml
	apply patch fml-support: 07762 From: Akira Ohashi
	make template of owner-* for qmail case.

	qmailの時に owner-* のためのtemplateファイルを作る
	(単なる便宜上)

  EnvelopeFilter
	fix paragraph count up method
	fix how to ignore the last paragraph as a signature

	パラグラフ数の数え方、signature部分の無視の仕方を少し変更

  doc/Japanese/

	とりあえずひととおり submit した

2000/04/12

  bin/fwix.pl
	automatically expand ".toc" command to
		"-" x 60
		table of contents
		"-" x 60

	TEXTモードでは .toc を枠つきの自動展開に変更

  doc/Japanese/

	大改造キャンペーン;)

2000/04/11

  bin/fwix.pl
	disable file existence introduced at 2000/04/10

  sbin/makefml (only on NT4)
	fix 'no such file' in "makefml passwd ..."
	by wrap "system stty " with "if $UNISTD"

	NT4 上で『そんなコマンドはない』というエラーメッセージが出る
	のをなおす。
	ただし以前からメッセージがでるけどパスワードの変更はできてい
	るという状態のはずなので、無視して使う分には別に問題はない;)

2000/04/10

  bin/fwix.pl
  distrib/mk/fml.turotial.mk
  doc/Japanese/
	rearrange documentation hierarchy. project phase 1 
	enhance bin/fwix.pl also to use X reference cache

	ドキュメント再構成計画 phase 1

	fwix は { label <=> xref } のリファレンスキャッシュと
	それを利用したディレクトリを越えた相互引用を可能にした

2000/04/01

   proc/libconfirm.pl
	define %CONFIRMATION_REPLY_WITH_HELP_P to handle whether we
	should reply help with $CONFIRM_FILE or not See also
	fml-support: 7723

	confirmationのエラーの時にいつでもヘルプファイルを
	つけるのは変なので、それを制御するハッシュテーブルを用意した

   modify how to use of $ENV{'PWD'}

2000/03/31

   EnvelopFilter
	skip plural null lines between paragraphs

	最初のＮ行のパラグラフをえぐりだす部分をなおす
	FIX: 複数の空行を一行とみなさないとおかしい

2000/03/26

   3.0.1 release

2000/03/25

   makefml
	apply patch (fml-support: 7706)

   makefml
	add prototype of new command "makefml showconfig" to show configuration
	For example:

	fml Release Version    3.0C (20000319)
	OS type                NETBSD1.4T
	CPU-MANUFACTURER-OS    i386-unknown-netbsd1.4T
	DOMAIN                 fml.org
	FQDN                   beth.fml.org

	makefml showconfig は自分の使っている環境の情報を表示する

	makefml bug-report-template はバグレポートを書く時のテンプレートを
	作成してくれる。
	わからないところは「わからない」でいいですが、
	この空白をできるだけ埋めてくれると嬉しい

		---------- fml bug report template ----------
		Template-Version:      0.8
		fml version:           3.0C (20000319)
		installation mode:     personal

		OS type:               NETBSD1.4T
		CPU-MANUFACTURER-OS:   i386-unknown-netbsd1.4T
		Perl version:          5.00503

		MTA:                   
		DOMAIN:                fml.org
		FQDN:                  beth.fml.org
		Email-Address:         fukachan@fml.org

		Description:           

		How-To-Repeat:         

		Fix:                   

   Clean up campaign: remove Open()

2000/03/21

   3.0C start

2000/03/19

   3.0B ends

	modified to fit new configuration loading

	configuration の読み込み方法の変更にともなう修正を
	一通り終えました。それにより current version 3.0B を close します。

	次は 3.0C (DB interface)の予定

   3.0B new load configuration final stage
	define prototype library to replace "require config.ph";

   removed:
	contrib/cwhois/
	contrib/crosspost/
	contrib/netutils/
	contrib/Obsolete/
	bin/Html.pl
	sbin/localtest.pl

	a part of clean up campaign
	cwhois is not maitained now. It is also not related with fml,
	move it to other ffs/ repository.

2000/03/18

   ReReRe problem
	apply patch from OGAWA Kunihiko (fml-support:7626,7653)

   $USE_HANKAKU_CONVERTER
	add $USE_HANKAKU_CONVERTER (Japanese specific)

	半角→全角コンバータを組み込む (optional)

   relay hack
	fix config file reading bug

2000/03/16

	fix RuleSetTo: 
	   use $addr not orignal addr in address rewriting

2000/03/15

 fix list file sendback code (current only)

	currentで members/actives コマンドを使う時に # の行が除かれない
	bug をなおす。stable は無関係

2000/03/10

 libtraffic.pl
	apply fml-support:7627 (patch by Yuao Tanigawa)
	import fix month update bug (libtraffic 1.3)

2000/03/09

  fix '# command' trap in the case of "com-mand"
	for example "unsubscribe-confirm" ( alphabets + "-")

	'# command'をトラップする場合に - を含むコマンドの場合のbugをつぶす

2000/03/08

   Re: Re: Re: 
	fix rurle to s/"Japanese Re:" Re:/ Re:/ to canonicalize subject to be
	"Subject: Re: ..." form.

   fix $REWRITE_TO == 1 behaviour
	fml-support: 07595

   fix envelope fileter

	unsubscribe XXXX YYYY だけのメールは弾くけど
	そのあとに改行がいっぱいある場合は one line body として弾かない。
	Filter code は先頭のＮパラグラフないし1024bytesだけを検査するが、
	パラグラフ数を数える時だけ元のメール本文を調べているのが bug 

2000/03/07

  bin/pmail.pl
	correct "-f MAIL-FROM" behaviour

  module/Japanese/
	apply patch fml-support: 7599,7600
	fix definitions, regexp

2000/03/01

  module/$LANGUAGE/: installation and enable them

	module/Japanese/liblangdep.pl

	日本語依存コード。レレレ問題コードをしこむ
	例: Subject: "返信:" を切り落とすため

2000/02/27

  new snapshot ID system
	new ftp hierarchy. For example

		current/fml-3.0B-current-YYYYMMDD.tar.gz
		stable/fml-3.0-stable-YYYYMMDD.tar.gz

2000/02/22

  3.0B newconfig: cf/config
	fix conversion dependence of explicitly defined keys in $DIR/cf

	『cfで定義されている変数』に依存する変数は config.ph で
	明示的に定義されるようにする。
	XXX 3.0B では default_config.ph を上書きする内容だけが
	XXX config.ph に明示的にコメントアウトされない行となるため	 

  sbin/makefml and drafts/{help, welcome, guide, ... } files
	Conv() use _MAINTAINER_ to make templates

	help ファイルなどのtemplate内部の _MAINTAINER_ を展開できるように
	また -admin のような埋め込み部分を _MAINTAINER_ に書き換え

2000/02/21

  CVS repository hier
	module/Japanese/	Japanese specific library
	module/compat/		compatible library

	CVSのディレクトリの整理

  doc/advisories/
	clean up

2000/02/20

  makefml install
	do not try to load /usr/local/fml/.fml/system in default
	makefml -a install tries to load /usr/local/fml/.fml/system if exists

	makefml install で /usr/local/fml/.fml/system などをさがして
	デフォルト値を探そうとするのをやめてみる。-a オプションをつけると
	以前の挙動(.fml/system を探そうとしてみる)にもどる。
	＃ virtual domain のときなどは不便なために不人気？
	＃ virtualでない人は default 値を推測してくれた方が便利だと思うんだが

2000/02/19

  CGI
	create ml-admin/$ml/htpasswd from /var/spool/$ml/etc/passwd
	if exists

	ある ML のCGI操作を有効にする際に htpasswd はもし $DIR/etc/passwd
	があればそれからCGI管理者初期ユーザリストを生成する。
	つまりコマンドを送り込める権限のユーザとCGI管理者は初期設定では
	同じ人々になる。

	XXX 特定の (e.g. elena) ML をCGI操作可能にした場合も
	XXX フレームバージョンにはやくしたいものだ

   doc/examples/
	add daily-renewal,  manual/

2000/02/18

  CGI
	fix mladminpasswd arguments bug

2000/02/17

  documents
	update test environments information

  CGI
	makefml mladmin.cgi ML installs .htaccess

	sort the result of ml choice

	add mladminpasswd

	   フレームメニューから管理者パスワードの設定画面へ飛ぶように

	index.cgi

	   管理者パスワードの設定をもどす

2000/02/15

  ReReRe problem
	cut off Re(2): and Re*2: in Subject:

	レレレ問題。切り落とすフォーマットを拡張
	今デフォルトで叩き落とすのは

	Re: Re2: Re[2]: Re(2): Re*2: Re^2: 

	など

  $TOP_DIR/CHANGES (this file :-)
	required for distributed environments

2000/02/13

  clean up campaign
	remove fmlctl

2000/02/12

  spool2html.pl
	add more debug info
	clean up

  $HTML_THREAD_SORT_TYPE
	value: "" / reverse-number

	スレッドの順番。デフォルトは記事の順番通り(上の方が過去)
	reverse-number にすると上の方が一番最近のもの

  bin/pmail.pl
	fix usage message
	fix includes

2000/02/11

  Re Re Re problem ;-)
	add to cut off Re\d+:

	レレレのおねえさん問題: Re数字: も切り落とすコードを追加 

  cf/MANIFEST
	clean up to remove the following definitions (not used):
		-FTPMAIL_SERVER:
		-FTP_DIR:
		-FTP_HELP_FILE:
		-DEFAULT_GOPHER_PORT:	
		-DEFAULT_GOPHER_SERVER:
		-DEFAULT_HTML_FIELD:
		-DEFAULT_HTTP_PORT:	
		-DEFAULT_HTTP_SERVER:

  doc/
	clean up doc/examples/

  CVS Repository

	move fml/doc/messages/ to fml/messages/

2000/02/09

  cf/
	more comments on USE_ORIGINAL_MESSAGE_ID

2000/02/08

  CGIのインストールドキュメント作成はじめました

2000/02/07

  newconfig
	generate default_config.ph in distribution package

2000/02/06

  CGI, makefml
	fix no frame version reworks

	enable log -DYYYYMMDD

	CGIから、ある"日"のログをみる

2000/02/03

  CGI
	clean up more

2000/02/02

  CGI FRAME VERSION !!!

	CGIフレームバージョン
	もぉ netscape なしにはデバッグできない;-)

  CGI
	"newml" calles "newaliases" automatically
	fix cgi miscellaneous installation bug ;)
 	fix MAIL_ADDR op bug (cannot insert new one;_;)

2000/01/31

  CGI modify and clean up menu

2000/01/30

  CGI
	add/remove      cgi admin
	change password cgi admin
	change each ml-admin cgi password

	管理者の追加/削除、パスワードの変更などなどさまざまな追加
	ドキュメントの整理整頓

	XXX いまや限りなくβバージョンといえよう

  CGI installation: fix cgi installation to make examples for MTA and httpd.

	CGIを使う場合のMTAとかhttpdの設定例で install にあわせたPATHへなおす

  makefml htpasswd ML username
	htpasswd wrapper for the ML

	htpasswd の wrapper 

	   % makefml htpasswd elena fukachan

	を実行すると

	   % /usr/pkg/bin/htpasswd  /usr/local/fml/www/authdb/ml-admin/elena/htpasswd fukachan
	New password: 

	のように変更するべきファイルを変更しようとする。

  sbin/makefml
 	fix to install $REAL_CGI_PATH/admin/.htaccess

	.htaccess のいんすとーる場所を $REAL_CGI_PATH へ修正

  makefml log ML [-LINES] [-pPATTERN] [-i]
	XXX enabel to use it via cgi interface

	-行数	最後の何行を表示するか
	-pパターン
	-i	case insensitiveでサーチするか否かのflag

	CGIでも使えるようにする

2000/01/29

  sbin/makefml
	import environment REAL_CGI_PATH,CGI_PATH

2000/01/28

  CGI
	enable mladmin.cgi via admin/menu.cgi

  modify messages in "newly added" case to use MesgLE().

  MesgLE
	doc/messages/Japanese/kern import errno 

  CGI
	modify directory hier to use share/ to be installed

2000/01/25

  start to fit 3.0B fukui-newconfig

  cgi menu for each ml for administrator

	それぞれの ML ごとの階層
	(サーバ管理者用、つまり通常makefmlが使用可能な人の権限)

2000/01/24

  makefml config Japanized menu 

	CGIでの日本語のメニュー

	CUI でもとりあえず環境変数 MAKEFML_LANG に何か設定すると
	日本語になる

	jcode.pl で使う euc, jis, sjis などを指定するとそれに変換してみる
	が、jis にすると他の正規表現ルールで引っかかるのでやはり euc が
	無難ぽい(default の文字コードは euc)

  makefml
	resolv conflicts around doc-template

	先日なおしたdoc-templateまわりの２つの修正がそれぞれは正しいが
 	２つあわさると互いに妨害してしまうbugの修正

  bug fix "admin matome addr 0"

	"admin matome addr 0" sends spool articles to the From: not
	the addr. 
	XXX we need to clean up mget3 interface but it is too complicated.
	XXX do dirty hack to avoid enbug anyway.

2000/01/23

  makefml
	fix menu to be [0] appera (not [n] !)

	fix CreateDocTemplate bug
	PR by fml-support:7167 NISHIGAWA Kazutaka <western@t3.rim.or.jp>

  cvsweb
	cvsweb ready

	http://mikoto.sapporo.iij.ad.jp/cgi-bin/cvsweb.cgi/

	cvsweb をつくりました。cvs.fml.org の CVS Repository に
	アクセスできます(read only)

  3.0B
	merge fukui-newconfig to enable new configuration evaluation order,
	which make the use of site*.ph be more useful.
	Author: Masayuki FUKUI <fukui@sonic.nm.fujitsu.co.jp>

	新(上位互換) configuration システム
	といってもconfig.phをどうこうというのではなく 
	site_init.ph の使用などをより便利に使うようにするためのもの

    References: fml-support: 06987

         cf/config
           → fml のインストール時に default_config.ph を作成するための
              オプションとして '-i' オプションを追加。
              '-i' オプション指定時は cf ファイル名の指定は不要で、
              cf/MANIFEST に記述されている全変数を有効にした config.ph を出力する
           → $DIR/cf ファイル指定時 (各ML での make config.ph 実行時) は、
              $DIR/cf ファイルで有効になっていない変数をコメントアウトした
              config.ph を出力するように変更

         sbin/makefml
           → fml のインストール時に cf/config を呼び出し、
              $EXEC_DIR/default_config.ph を作成する処理を追加
           → 上記に伴い sub MakeConfigPH 内を修正

         src/fml.pl
           → site_init.ph を require する前に、
              default_config.ph の require を追加
           → sitedef.ph を obsolete し、site_force.ph に変更
              (実際には、site_force.ph がなければ、
               sitedef.ph を require するようになっている)

2000/01/22

  makefml resend ML [ID] [address]

	特定の記事をフォワードする。単に bin/resend.pl  を呼ぶだけ:)

	makefml resend ML だけで起動すれば対話モードになる

  bin/resend.pl
	Usage: bin/resend.pl [-dh] [ID] [RCPT]

	    [options]
	    -d debug
	    -h this help
	    ID     article number/ID
	    RCPT   Receiver Email Address

	特定の記事をフォワードするコマンド
	単に sendmail にわたすだけなので sendmail 互換コマンドを
	用意してあることが必要

	IDとかRCPTを引数にとらない場合は入力するよう促される

2000/01/21

  sbin/makefml
	use current cf value in y/n query menu

	y/nでメニューに答える時はcfにある値をデフォルト値として
	メニューにだす

2000/01/20

	fix to enable $DEFAULT_RELAY_SERVER even if command reply 

	コマンドの返事などでも$DEFAULT_RELAY_SERVERが有効になるように
	変更

	add mesg le debug

2000/01/16
	add fml/fmlmk.conf.example (cvs repository)

	clean up documents (fml-stable only)

	etc/makefml/menu.conf: (1.18-1.19)
		fix typo. PR 7165 from OGAWA Kunihiko

2000/01/14

  bin/spool2html
	sync w/ HEAD (2.11-2.12): fix GetMax()
	patch from MURASHITA Takuya (fml-support: 7215)

2000/01/13

  sbin/makefml 
	doc-template:
	repl $ctladdr with %config value' sbin/makefml
	PR from Teruyuki Morimura  fml-support:7244

2000/01/11

  sbin/makefml
	do_create_doc_template():
	overwrite %config by evaled (config.ph) values.
	since cf has raw value e.g. elena@$DOMAINNAME, so we need to eval it.

	make doc-template の時の変換バグをつぶす

2000/01/10

  new daily-snapshots system be appearing .. on ftp and www server
	with a little transfer miss now;-) now I'm tuning it.

	新日がわりスナップショット・システム 
	ftp, www 上で見えます。ちょっとまだパラメータあわせが完全じゃないけど
	www 上のほうがちゃんとみえてるでしょう

  ftp://ftp.iij.ad.jp/pub/IIJ/dist/fukachan/fml/daily-snapshots/current/

	current daily snapshot	

  ftp://ftp.iij.ad.jp/pub/IIJ/dist/fukachan/fml/daily-snapshots/stable/

	stable branch daily snapshot

2000/01/07

  CGI Interface
         PR from ikeda <ikeda@maple.or.jp>
         fix variable import bug
	  (www/lib/libcgi_kern)

	fml 3.0pl#18 == fml 3.0.1_BETA #7

	リリースエンジニアリングがちょっと戻ってます。
	fml 3.0pl#18 は fml 3.0.1_BETA #7 の扱いです。
	ファイル名だけは3.0.1_BETAですがひろげても 3.0.1_BETA と表示さ
	れません。が、そういうもんだとおもって下さい :)

2000/01/06

  www.fml.org
	change search engine to namazu

	検索エンジンを namazu へ移行

  spool2html
	fix bug no variable import from config.ph

	config.ph の内容を反映しないのを修正

2000/01/05

  fix miscellaneous y2k
	PR by fml-support: 07189 OGAWA Kunihiko

	bin/daily.pl
	bin/gen_summary.pl
	bin/spool2html.pl
	contrib/utilities/packmbox.pl
	contrib/localhack/release-1/vote/vote.pl

	y2k?
	  src/libcompat.pl
	  rc/libcompat_fml15.pl

  bin/passwd.pl
	PR fml-support: 07190 Masaaki Hirono
	fix undefined function bug
	see also libcrypt.pl change below

  libcrypt.pl
 	fix SRand() call bug

2000/01/02
  make current snapshot

	CGI pre βバージョン(?)

  FILTER_ATTR_REJECT_INVALID_JAPANESE (optional)
	reject not ascii nor ISO-2022-JP
	(variable name is appropriate ???)

	フィルタ: 変な日本語ぽいメールを拒否。デフォルトではつかってない
	XXX こんな変数名でいいのか？？？

  html generator
	fix title to YYYY/MM/DD
	PR of fml-support:7172,7173
	Thanks OGAWA Kunihiko, Satoru FUJITANI

1999/12/30
	fix bin/fwix.pl cross referencing bug
	new CVS repository dist/ for original source distribution location

1999/12/29
	3.0.1_BETA#2

	update jcode.pl to 2.11
	fix url in doc/smm/hack.wix	
	update bin/multipart.pl
	update libtraffic.pl to fix y2k

1999/12/26
	3.0.1_BETA#1 (cristmas present :-)

1999/12/20
	prepare 3.0.1 release ...

1999/12/13

  CMesg(): Mesg() with negative cache
  CWarn(): Warn() with negative cache

	negative cache つきの汎用性のある Mesg をwrapする関数を用意する
	汎用のものなのでいろいろ使い出があるはず

1999/12/11

  makefml
	avoid regexp address (incomplete fix, see TODO list)

	makefml bye ML 正規表現のようなアドレス 

	問題のtrickyな回避。もっとちゃんと書きなおすべき。TODOをみよう

  update TODO, html/nt.html

1999/12/06

  libmember_name.pl
	hide apporove password logged in logfile

1999/11/29

   remove obsolete files from standard distribution
	bin/geturl.pl
	etc/crontab-4.3
	etc/crontab-4.4
	etc/passwd

1999/11/27

   installer
	"makefml -W cgi install" which setups cgi

	CGIのインストール

   installer
	you can use both MKDOC=no and MKDOC=NO

	MKDOC=no =NO どっちでも使えるように修正
	＃ MKDOC=no を環境変数に設定するとドキュメントをインストールしない 

	例:	env MKDOC=no make install

1999/11/26

   doc/{html,ri}/
	fix some ptr and lexical (for html generation) bugs

   bug fix Japanese reply message in moderator mode
	# Thank Satoshi Tatsuoka for the patch

	モデレーターモードで投稿確認の日本語のメッセージが表示されない

1999/11/23

   sbin/makefml	(2.44-2.45)
	validate config.guess existence

1999/11/19

   [ 3.0pl11 ]

   proc/libra.pl
	fix typo
	by <yuao@infonia.ne.jp> fml-support:06999 

   kenn/fml.pl
	if handler == ignore in command mode, ignore all requests

   bin/spool2html.pl
	define $Envelope{'mode:dist'} to avoid libsynchtml check

	SyncHtml()の新しいチェックにひっかかる

   etc/makefml/Makefile (1.16-1.17)
	validate config.ph.new before mv .ph.new to .ph

1999/11/18

   proc/libra.pl
	fix typo of "admin add" command reply
	by <yuao@infonia.ne.jp> fml-support:06999 

	admin add の返事の日本語のメッセージがおかしい;0

1999/11/17

   kenn/fml.pl
	if handler == ignore in command mode, ignore all requests

	コマンドで ignore を指定するとすべてのリクエストを無視する
	ように変更(guideやsubscribe,chaddrだけは受け付けてしまっていた)

1999/11/15

   bin/spool2html.pl
	define $Envelope{'mode:dist'} to avoid libsynchtml check

	SyncHtml()の新しいチェックにひっかかる

   etc/makefml/Makefile (1.16-1.17)
	validate config.ph.new before mv .ph.new to .ph

1999/11/14
   -------------------------------------------------------------------
   [ 3.0pl10 ]
   bin/fwix.pl
	fix IndexExpand() avoid to match unexpected '+' string
   doc/
	add simple installa memo on qmail
	http://www.y-min.or.jp/~nob/qmail/qmail+fml.html
   sbin/makefml (2.43-2.44)
	define dummy DEFINE_FIELD_PAT_TO_REJECT()
   -------------------------------------------------------------------

   bug fix (current only): actives/members not cut off comment lines with /^#/

	actives members で # ではじまるコメント行がのぞかれない
	(currentだけのbug)

1999/11/09

   bin/fwix.pl

	fix IndexExpand() avoid to match unexpected '+' string

	+ をふくむURLをちゃんとparseできなさげ?なbug fix

   doc/

	add simple installa memo on qmail
	http://www.y-min.or.jp/~nob/qmail/qmail+fml.html

	qmail の簡単なインストールメモを付け加えさせてもらう

1999/11/08

   sbin/makefml: bug fix (missing definition)

	Undefined subroutine &config_ph::DEFINE_FIELD_PAT_TO_REJECT called at 
	/var/spool/ml/elena/config.ph line 1293.

	「DEFINE_FIELD_PAT_TO_REJECTがないのでエラー」となるbug fix

   add new CVS repository: fml/doc/devel/

	a small memo's for developements

	doc/devel/ は開発(者)用のメモとして整理する予定
	(devel == developement)

   [ 3.0pl9 ]
   fix qmail examples (qmail/users/assign)

   fix qmail examples (qmail/users/assign)

	change
		   +elena-:fukachan:1000:1000:/a:-::
	   to
		   +elena:fukachan:1000:1000:/a:-:elena:
	style

	makefml newml時に生成されるqmailの見本のbug fix

1999/10/29

   [ 3.0pl8 ] 

   fix "admin remove-article" command bug with html creation mode

	XXX should not run &SyncHtml() under command mode

	HTMLスプールを生成することになっている場合に"admin remove-article"
	command を使うとその命令を送ったメールもついでに再生成されてしまうbug

   [ 3.0pl7 ] 

   etc/makefml/dot-qmail-default 

	s/USE_QMAIL_EXTENSION/USE_DOT_QMAIL_EXT/
	$USE_QMAIL_EXTENSION is renamed to $USE_DOT_QMAIL_EXT.

	$USE_QMAIL_EXTENSION は $USE_DOT_QMAIL_EXT に改名されている。

   proc/libexpire.pl 
	expire spooled articles based on mtime not ctime
	fml-support: 6867

	なぜかexpireのコードのところ一箇所でだけ判定の基準が異なることを修正

  libexec/mead.pl
	trap postfix error messages (true?)
	trap more qmail error messages (sync w/ HEAD 1.8-1.9)

  libexec/mead.pl, doc/smm/mead.wix
	add missing options mead.pl help shows

1999/10/28

   cf/MANIFEST cf/MANIFEST.Japanese

	add missing USE_DOT_QMAIL_EXT definition

   etc/makefml/dot-qmail-default 

	s/USE_QMAIL_EXTENSION/USE_DOT_QMAIL_EXT/
	$USE_QMAIL_EXTENSION is renamed to $USE_DOT_QMAIL_EXT.

	$USE_QMAIL_EXTENSION は $USE_DOT_QMAIL_EXT に改名されている。

   proc/libexpire.pl 
	expire spooled articles based on mtime not ctime
	fml-support: 6867

	なぜかexpireのコードのところ一箇所でだけ判定の基準が異なることを修正

   sbin/makefml
	fix $ML_DIR/etc/aliases generation
	fml-support: 6903

	fml-currentのmakefmlがエラーをはくことを修正(CGI 開発branchの余波)

1999/10/26

   aliases example

	add owner-ml-ctl: $user

	newl 時に作成されるaliasesファイルに owner-ml-ctl を加える

1999/10/18
   admin iam

	add administrative "iam" command to overwrite entry for the addr

	管理者用のiam: 既存ユーザのエントリの強制上書き/削除用

  libexec/mead.pl
	trap more qmail error messages

	qmail のエラーの解析をもうちょっと頑張る

1999/10/05
  3.0A (fml-current)

	3.0A (fml-current) スタート
		設定のための WWW/CGI Interface (αテスト)
		clean up 他

  libexec/mead.pl

	trap postfix error messages (true?)

	postfix のエラーの解析をもうちょっと頑張る

  ftp://ftp.iij.ad.jp/pub/IIJ/dist/fukachan/fml/htmldocs-current.tar.gz
  ftp://ftp.iij.ad.jp/pub/IIJ/dist/fukachan/fml/htmldocs-YYYYMMDD.tar.gz

	package of html documents under http://www.fml.org/fml/

	http://www.fml.org/fml/ の下のドキュメントをまとめたもの

1999/10/04
  3.0pl6

  clean up/changes documents mainly

  bin/fwix.pl
	not expand .ptr with <PRE>

1999/09/26
  3.0pl5

  sbin/makefml
	PR: fml-support:06764
	fix "auto_asymmetic_regist" behaviour
	which affects libexec/mead.pl remove user process ;-)

  doc/ri/INSTALL.wix
	 add note on "makefml -U install" (unlock mode)

  examples/fml-install.wix
	unify makefml syntax example to be easy for beginners

  proc/libra.pl
	fix file validation check" in the case regexp-like directory name

  update (sync with HEAD (cvs main trunk))
	INSTALL_on_MacOS_X_Server

1999/09/20
  3.0pl4

  etc/makefml/include-mead
	fix spelling 

  doc/html/index.html
	add ptr to Mac OS X Server

  cf/MANIFEST
	clean up English ;-)
	sync with fml 3.0 etc/makefml/cf

  cf/MANIFEST.Japanese
	added. Japanese description for variables

1999/09/18
   3.0pl3 

   add INSTALLATION NOTES on MacOS X Server

   proc/libsynchtml.pl 
	fix dup check of htdocs/index.html

   proc/libmesgle.pl 
	&Mesg() repl may has invalid input
	check the input and wrap repl in euc and back to jis

   sbin/makefml
	modify jperl check code

   fix distribution package lacks some plaintext
	distribute all INSTALL* (plaintext) 

   proc/libra.pl
	remove-article always checks spool and archive (tar.gz)

   doc/ri/README.wix
   doc/ri/INSTALL.wix
	fix 2 bytes "-" statements (Japanese specific)

1999/09/02
   3.0pl2 (fml-3.0pl2.tar.gz, patchlevel 2)

   doc/ri/
   doc/examples/
	sync with cvs main-trunk

   libmember_name.pl
	correct handling of "apporove PASSWORD name ..." case

1999/08/28
   3.0pl1 (fml-3.0pl1.tar.gz, patchlevel 1)

	cf/config
		TZone cannot accpet -0800 style.

	doc/examples/index*html
		remove fml.css stylesheet definition since fml.css does not exist

	doc/ri/INSTALL.wix
		add how to pass perl path in "make install"
		   % env _PATH_PERL=/usr/local/bin/perl5 perl makefml install

	sbin/makefml
		fix perl path in "make install"
		   % env _PATH_PERL=/usr/local/bin/perl5 perl makefml install
		add COPY_FIELD() to avoid evaluation of config.ph loading

1999/08/15
   3.0 Release

1999/08/11
	fix sbin/makefml bug (loading config.ph)
	cut off Subject: trailing \s+ against some MUA ;_;

1999/07/26
   remove useless message reply in "unsubscribe-confirm" success 

1999/07/25
   makefml: not need $DIR/cf if possible

	makefmlはcfを使っていない場合にはconfig.phだけ評価すればいい
	ように修正

1999/07/20
	Loop check: always reject from: MAIL_LIST, CONTROL_ADDRESS, ...

	いかなる場合でも From: がメーリングリストやコマンド用のアドレス
	だったら途中で処理を停止する。

	update several documents

1999/07/19
	3.0_BETA

1999/07/18
	change $SKIP_FIELDS default to pass through Received:. 
	It causes too many hops but need to check spam or back trace.

	SKIP_FIELDS のデフォルトを変更して Received: を通すのがデフォルト

1999/07/11
   SMTP new library: if $MCI_SMTP_HOSTS > 1 case

	fix bug MCI window
	smtp does not send the last $MCI_SMTP_HOSTS recipients ;)

	$MCI_SMTP_HOSTS > 1 の時のみ
	新SMTPライブラリのbug fix

1999/07/10
   HTML_THREAD_REF_TYPE: change "default" to "prefer-in-reply-to"

1999/07/09
	s/auto_symmeric_regist/auto_subscribe/

  2.2F	merge mci-window2 branch
	more elabarate recipient list division

	より賢いSMTP配送リスト分割
	modulus 法はobsolete

1999/07/05
   2.2E#5
   EnvelopeFilter: fix 'one line body' check bug

	fix couting number of paragraph

1999/07/02
   handling attachemnt in multipart mail
	split each multipart block to each file
	We can handle text/plain, text/html, base64 encoded file ;-) only

	HTMLジェネレータがMultipartの時は貼付ファイルをばらばらのURLに
	分離してみようと試みるだよ

1999/07/01
   2.2E#1	[less momory hack] part I

		fix a lot of main code (fml.pl)
		completely rewrite multipart to html generator (libsynchtml.pl)
		rewrite virus check code (libvirus.pl)

	&ADD_CONTENTS_HANDER
		apply patch of fml-support:6396 to fix  regexp

1999/06/29
   2.2E		less momory smtp IO library

	2.2E: SMTPライブラリの改良

1999/06/27
	new handler: "auto_symmetric_regist" to resolve 
	asymmetric treating of "members" and "actives" files.
	It will be fml 3.0 future.

1999/06/26
   2.2D
	2.2C: smtp hack (1/2) for pipelining
	2.2D: auto_symmetric_regist

1999/06/25
   HTML generation: $AUTO_HTML_GEN

	(a little) more smart memory use of base64decoding

1999/06/23
   EnvelopeFilter: modify 2-byte-codes filtering code (Japanese sepcific)

	２バイトコード排除の仕方をちょっと変更する。
	排除するパターン

	   ^２バイト[A-Za-z]２文字以上連続$
	   ^２バイト[A-Za-z]２文字以上連続 + スペース  + なんでも
	   ^２バイト[A-Za-z]２文字以上連続 + ２バイトスペース + なんでも

	mead: pick up Received: for <address> line for mail forwarding case

1999/06/22
	fix PIPELINING. 

	add flow control of RCPT TO: rate.

	PIPELINGの時突っ込んではちょっと受け取ってを
	くりかえしていくように flow control のようなことをする。

1999/06/18
	VERPs: Variable Envelope Return Paths
	See http://www.jp.qmail.org/qmaildoc/RFC/RFCVERP.html
	If you enable $USE_VERP variable, fml uses VERPs.

		$USE_VERP = 1; (default 0)

1999/06/16
	loop detection based on MD5 check sum of article

	ループ対策その３
	md5 チェックサムのキャッシュを持ち記事の重複をチェックする
	(一応デフォルトではこの機能は有効にはしていない)

	[config.ph]
		$CHECK_MAILBODY_CKSUM = 1;

	[makefml config]
	   top menu => SECURITY_AND_FILTER => CHECK_MAILBODY_CKSUM => "y"

1999/06/14
	make FEATURES document/web page from README

	WWW.FML.ORGに FEATURES (特徴)だけのページを作る

1999/06/08
	fix command mode moderation

	modify messages/Japanese/amctl (amctl.added)
	to be more readable at a glance

1999/06/07
	bug fix html mail filtering code
	新しいHTMLメール(なんていうんだ?)フィルタリングコード bug fix 版

1999/06/04
	fml-support:6245
	contributed by <t-nakano@ccs.mt.nec.co.jp>.
	import new html_mail(?) filtering code (beta test?).
	Now we can set each policy e.g. permit/deny for each multipart block.

	新しいHTMLメール(なんていうんだ?)フィルタリングコード
	multipartの各ブロックごとに制御できる。
	(Author: <t-nakano@ccs.mt.nec.co.jp>)

	Example:

 	&ADD_CONTENT_HANDLER('multipart/*', 'text/plain', 'allow');
 	&ADD_CONTENT_HANDLER('multipart/*', '*/*',        'reject');
 	&ADD_CONTENT_HANDLER('text/plain',  '*/*',        'allow');
 	&ADD_CONTENT_HANDLER('!MIME',       '*/*',        'allow');

1999/06/03
	bug fix confirmation message
	(resolve duplicated entry in doc/message/Japanese/)

1999/07/09
	s/auto_symmeric_regist/auto_subscribe/

  2.2F	merge mci-window2 branch
	more elabarate recipient list division

	より賢いSMTP配送リスト分割
	modulus 法はobsolete

1999/07/05
   2.2E#5
   EnvelopeFilter: fix 'one line body' check bug

	fix couting number of paragraph

1999/07/02
   handling attachemnt in multipart mail
	split each multipart block to each file
	We can handle text/plain, text/html, base64 encoded file ;-) only

	HTMLジェネレータがMultipartの時は貼付ファイルをばらばらのURLに
	分離してみようと試みるだよ

1999/07/01
   2.2E#1	[less momory hack] part I

		fix a lot of main code (fml.pl)
		completely rewrite multipart to html generator (libsynchtml.pl)
		rewrite virus check code (libvirus.pl)

	&ADD_CONTENTS_HANDER
		apply patch of fml-support:6396 to fix  regexp

1999/06/29
   2.2E		less momory smtp IO library

	2.2E: SMTPライブラリの改良

1999/06/27
	new handler: "auto_symmetric_regist" to resolve 
	asymmetric treating of "members" and "actives" files.
	It will be fml 3.0 future.

1999/06/26
   2.2D
	2.2C: smtp hack (1/2) for pipelining
	2.2D: auto_symmetric_regist

1999/06/25
   HTML generation: $AUTO_HTML_GEN

	(a little) more smart memory use of base64decoding

1999/06/23
   EnvelopeFilter: modify 2-byte-codes filtering code (Japanese sepcific)

	２バイトコード排除の仕方をちょっと変更する。
	排除するパターン

	   ^２バイト[A-Za-z]２文字以上連続$
	   ^２バイト[A-Za-z]２文字以上連続 + スペース  + なんでも
	   ^２バイト[A-Za-z]２文字以上連続 + ２バイトスペース + なんでも

	mead: pick up Received: for <address> line for mail forwarding case

1999/06/22
	fix PIPELINING. 

	add flow control of RCPT TO: rate.

	PIPELINGの時突っ込んではちょっと受け取ってを
	くりかえしていくように flow control のようなことをする。

1999/06/18
	VERPs: Variable Envelope Return Paths
	See http://www.jp.qmail.org/qmaildoc/RFC/RFCVERP.html
	If you enable $USE_VERP variable, fml uses VERPs.

		$USE_VERP = 1; (default 0)

1999/06/16
	loop detection based on MD5 check sum of article

	ループ対策その３
	md5 チェックサムのキャッシュを持ち記事の重複をチェックする
	(一応デフォルトではこの機能は有効にはしていない)

	[config.ph]
		$CHECK_MAILBODY_CKSUM = 1;

	[makefml config]
	   top menu => SECURITY_AND_FILTER => CHECK_MAILBODY_CKSUM => "y"

1999/06/14
	make FEATURES document/web page from README

	WWW.FML.ORGに FEATURES (特徴)だけのページを作る

1999/06/08
	fix command mode moderation

	modify messages/Japanese/amctl (amctl.added)
	to be more readable at a glance

1999/06/07
	bug fix html mail filtering code
	新しいHTMLメール(なんていうんだ?)フィルタリングコード bug fix 版

1999/06/04
	fml-support:6245
	contributed by <t-nakano@ccs.mt.nec.co.jp>.
	import new html_mail(?) filtering code (beta test?).
	Now we can set each policy e.g. permit/deny for each multipart block.

	新しいHTMLメール(なんていうんだ?)フィルタリングコード
	multipartの各ブロックごとに制御できる。
	(Author: <t-nakano@ccs.mt.nec.co.jp>)

	Example:

 	&ADD_CONTENT_HANDLER('multipart/*', 'text/plain', 'allow');
 	&ADD_CONTENT_HANDLER('multipart/*', '*/*',        'reject');
 	&ADD_CONTENT_HANDLER('text/plain',  '*/*',        'allow');
 	&ADD_CONTENT_HANDLER('!MIME',       '*/*',        'allow');

1999/06/03
	bug fix confirmation message
	(resolve duplicated entry in doc/message/Japanese/)

1999/05/31
	chaddr: bug fix address similarity check

	chaddr 時に chaddr A B で AとBが似ている場合にはアドレスの
	チェックを厳しくしているがその厳しさ判定のバグFIX

1999/05/30
	bug fix Copy() permission preservation

1999/05/19
	start 2.2C

	when $SMTP_SORT_DOMAIN is set.
	split recipients list to some windows not divided by modulus 

	$SMTP_SORT_DOMAIN の時は配送リストをmodulusで分割ではなく
	連続したいくつかの領域にわける。

1999/05/11
	2.2.1 release

1999/05/10
	bug fix makefml:
	   die() does not unlink lockfile NOT IN flock(2) case.

	   link(2)を使うロックの異常終了の処理時のbug fix

1999/05/08
	bug fix html generator

	HTML のbase64デコーダーの呼び出し方のバグFIX

1999/05/06
	fmlserv MesgLE

1999/05/03
	2.2B#6
	Message Language Extension phase 3

	&LogWEnv()まわりも日本語化。日本語化ひととおり終了！

1999/05/02
	2.2B#5

	Message Language Extension phase 2

	&Mesg()関係はとりあえず日本語(２か国語で表示)になった

	インストール時のデフォルトを $LANGUAGE と同じにしておく
	(つまりデフォルトでONにする)

1999/04/27
   $HTML_MAIL_DEFAULT_HANDLER	(obsolete $AGAINST_HTML_MAIL_HANDLER)

	No, nameing is incorrect! Following fml-support: 05979
	rename $AGAINST_HTML_MAIL_HANDLER $HTML_MAIL_DEFAULT_HANDLER
	since $AGAINST_HTML_MAIL_HANDLER looks strange convention.

1999/04/24
   $AGAINST_HTML_MAIL_HANDLER

1999/04/23
   fix typo etc/makefml/menu.conf

1999/04/21
	fixes 'matome' command bugs (fixed but not in essential ;_;)

1999/04/19
	fml 2.2.1_BETA phase 

	code freeze しました。fml 2.2.1_BETAは main trunk から分離し
	２週間テストの予定です。その後リリースになります。

	   2.2 -----> 2.2 A -----> 2.2B ----->	(main trunk)
	                      |
	                  2.2.1 BETA		(branch)
	                      |
	                  2.2.1 Release

1999/04/18
	add new search path for sitedef.ph site_init.ph

		$ML_DIR/etc/fml/ (e.g. /var/spool/ml/etc/fml/sitedef.ph)

	so the current search order is 

		$ML_DIR/etc/fml/	/var/spool/ml/etc/fml/
		$DIR			/var/spool/ml/elena/
		$EXEC_DIR		/usr/local/fml/
		PERL standard path	@INC

1999/04/17
	makefml update file:

	update README for 2.2.1

1999/04/15
	etc/makefml/menu.conf: 	add option->USE_MEMBER_NAME

1999/04/14
	expire old articles: bug fix critical bug

	chaddr: check oldaddr != newaddr

1999/04/11
	2.2A#49 chaddr confirmation

	chaddr confirmation をmergeしました。

	$CHADDR_AUTH_TYPE = 'confirmation'; 

	を設定するとchaddrコマンドにconfirmation(確認)が要求されます
	confirmationの場合は新旧アドレスどちらからでもchaddr可能です。

	confirmation なしのchaddrは旧アドレスからのみchaddr可能です。

1999/04/10
	bug fix FmlExitHook for library 

1999/04/08
	bug fix chaddr:
		reject curaddr==newaddr case firstly

1999/04/07
	domain-translate: update list
		fix file permission preservation

1999/04/03
	domain-translate: bug fix rules

	doc/man/:  add nroff manuals

1999/04/02
	bug fix bin/more_secure_cf.pl variable substibution

	bin/more_secure_cf.pl の変数置換のbug fix 

	adjust doc/advisories/

1999/04/01
	(2.2A#42)

	FML Advisory 1999-04: Melissa Familly Macro Virus

	Melissaと同じ祖先を持つウィルス一族への対策について

	libviruschk.pl: added

1999/03/29
	FML Advisory 1999-03: Melissa Macro Virus

1999/03/28
	FML Advisory 1999-02: or.jp -> ne.jp problems

1999/03/27
   or.jp -> ne.jp translator: Japanese specific

	or.jp -> ne.jp へメンバーファイルなどを変換するツールを
	加える。 ML のディレクトリで

		make translate-domain

	を実行すると or.jp -> ne.jp 移行をするドメインをne.jpに移行する

	注意: これでメールソフトの設定をちゃんと更新しないメンバーは
	逆に"メンバーではない"といわれるようになることに注意。	

1999/03/26
   HTML Generator: define umask variables

	$HTML_DEFAULT_UMASK
	$HTML_WRITE_UMASK

1999/03/25
   EnvelopeFilter: fix 2-byte command filter toggle flag
	if $FILTER_ATTR_REJECT_2BYTES_COMMAND is defined, 
	reject 2-bytes commands.

	$FILTER_ATTR_REJECT_2BYTES_COMMAND が定義されている時だけ
	２バイトコマンドを拒否する

1999/03/16
   EnvelopeFilter: fix 2-byte command rejection (Japanese specific)

	bug fix: 日本語英文字コマンドの拒否のバグFIX
		拒否 "ＵＮＳＵＢＳＣＲＩＢＥ"
		拒否 "ＵＮＳＵＢＳＣＲＩＢＥ なんか"
		拒否 "ＵＮＳＵＢＳＣＲＩＢＥ　なんか"
		OK   "ＵＮＳＵＢＳＣＲＩＢＥざますぅ。"
	など

1999/03/14
   chaddr: implement $CHADDR_AUTH_TYPE == confirmation mode

	chaddr の confirmation の実装

   fmlserv: listserv style interface
	clean up for 2.2.1

   cf/MANIFEST: add value: definition for each variable

	各変数にとりうる値についてのコメントをつける

1999/03/13
   2.1A#37: rearrange doc/op for 2.2.1

	ただいま2.2.1にむけての整備まっしぐら月間

1999/03/09
   mead.pl: consider DSN also

1999/02/28
   cf/MANIFEST: update definitions

1999/02/27
   EnvelopeFilter: reject 2 byte alphabets

   ［フィルタリングルールの追加］
	メールの最初のパラグラフに
	"ＵＮＳＵＢＳＣＲＩＢＥ ほえほえ" のような２バイト英文字ではじまる
	行があったらREJECTする。

1999/02/26
   FML Advisory 1999-001: happy99.exe 

	[www] http://www.fml.org/fml/advisories/happy99/

	FMLアドバイザリィ  happy99.exe 対策を加えました。
	doc/advisories/も他のドキュメント同様WWWとPlainTextです。

   CHADDR: remove $MAINTAINER as a copied user but enable
	$Procedure{'r2a#chaddr'} control.  

   BYE:	remove additional info e.g. "change delivery list.." in
	default but works under $debug_amctl on.

    makefml: check ADDR_CHECK_MAX value whether defined or not.

1999/02/24
   makefml:
	show more explicitly /etc/aliases example

   AddressMatch: 
	more polite or friendly message

   DEFINE_FIELD_PAT_TO_REJECT: 
	enhance arguments to be (field,	pat, reason) 

    EnvelopeFilter: 
	modify 'invalid command line' pattern to reject '% echo ...' 
	line with or without lines/paragraphs after it.

1998/02/23
	clean up for more y2k

1998/02/21
	against "happy99.exe"
	bin/multipart.pl : reject happy99

	bug fix: active/member asymmetric registerd case.

	   bug fix: actives/membersの片方にしかアドレスがない場合の挙動

1998/02/17
   include-outgoing:
	remove DISTRIBUTE_DUMMY_RECIPIENT and define
	$USE_OUTGOING_ADDRESS	1/0 (== yes/no)
	$OUTGOING_ADDRESS	address

	if ($USE_OUTGOING_ADDRESS) {
		fml sends article to $OUTGOING_ADDRESS.
	}

	1.	include の見本を作る(include-outgoing)

	   % cd /var/spool/ml/elena
	   % make outgoing 

	2.	/etc/aliases に書く

	   elena-outgoing: :include:/var/spool/ml/elena/include-outgoing

	3. 	makefml config で enable

		-> OPTIONS -> SMTP -> USE_OUTGOING_ADDREESS -> "y"

1998/02/12
   bin/pmail.pl: update and extend it

1998/02/11
   include-outgoing:
	You can use "make outgoing" now.
	add "include-outgoing" and remove "include-disthack"

	DISTRIBUTE_DUMMY_RECIPIENT 	list-outgoing@$DOMAINNAME

    $AGAINST_MAIL_WITHOUT_REFERENCE
	check References: and In-Reply-To: field has already
	Message-ID we intend to add now.

	References:/In-Reply-To: がこれからつけようとしている
	Message-ID:を持っているかどうかをチェック。
	既についていたらつけない。

1998/02/08
	Y2K: $Now becomes ' 0/01/01' not '00/01/01'.
	     IT SHOULD TO BE '00/01/01', is'nt it?

1998/02/05
	update jcode.pl to 2.10
	update mime_pls to 2.02
	modify libMIME.pl to use mime_pls 2.02

1998/02/03
	Added: doc/ri/INSTALL_with_ZMAILER

	bug fix: fml on nt (pop version) overwrites sitedef.ph but
		 SHOULD NOT DO IT. 

1999/02/01
	begin to prepare 2.2.1 release ...

1999/01/31
	Added: doc/ri/INSTALL_with_POSTFIX

	For convenience, I split INSTALL*wix to INSTALL_with_"MTA".wix.
	So now available documents specific for a MTA are:

		INSTALL_with_SENDMAIL (almost dummy file :-)
		INSTALL_with_POSTFIX
		INSTALL_with_QMAIL
		INSTALL_with_EXIM

1999/01/25
    SMTP bug fix: remove a too restrict error condition
    # XXX this condition is too restrict since this traps
    # XXX direct local delivery errors ;D

1999/01/24
    $MODERATOR_EXPIRE_LIMIT: (default 14 == 2 weeks)
    bug fix: expire moderator mail queue

	モデレータの時(TYPE II,III)の古いqueueの削除

1999/01/21
	add another loop detection: X-ML-Info: check

1999/01/20
	bug fix: re-configure we should import 1.11a mime library no 1.1
		PR: fml-support: 05735

1999/01/15
	$AGAINST_MAIL_WITHOUT_REFERENCE;
	0. you require to set up 'fml puts the subject tag'.
	1. add ML specific Message-ID: 
	2. analyze the subject tag e.g. Subject: Re: [elena 00100]
	In this mode, fml emulates Message-ID: always based on rule 2. 
	Hence fml can ensure the consistency of ML threads against
	some MUA's e.g. old Eudora...

	非常〜〜に後ろ向きなオプション
	Eudora 等の In-Reply-To: References: をつけてくれないMUA対策
	0. Subject: にTAGをつけることは前提(not default)
	1. Message-ID: は ML 独自のものをつける
	2. Subject: Re: [elena 00100] のようなTAGを解析する
	ことで ML 全体のスレッドの一貫性を疑似的に強制する。
	元のMessage-ID:はX-Original-Message-ID:に移動される
	(#28はbugでつけてない, fixed in #29)

	$AGAINST_HTML_MAIL: cut off except the first multipart block

	OUTLOOKからHTML貼付メールを送りつけてきたら、最初のブロックだ
	け残してぶった切るスーパー極悪オプション。
	(企画名 $AGAINST_OUTLOOK :-)

1998/12/27
   DISTRIBUTE_DUMMY_RECIPIENT: dedicated to minmin sama:-)
	decrease perl resident time for on a weak machine e.g. 486DX.
	add "include-disthack".

	みんみん様にささぐ :) perl の滞在時間をできるだけ少なくする工夫
	1. fml はある一つのアドレス ML-dist に投げるだけで終了
	2. ML-dist は :include:$DIR/var/db/rcptlist を行う。
	   つまり配送の実態が ML-dist である。

	3. このためのaliasesの見本として$DIR/.include-disthackが作成される
	   のでこれを使うと良い。
	   /etc/aliases を変更する

	4. cf に DISTRIBUTE_DUMMY_RECIPIENT にアドレスをかく
	例:

		DISTRIBUTE_DUMMY_RECIPIENT 	list-dist@$DOMAINNAME

	5. MLのHOMEで、make config.ph で config.ph を再生成
	6. MLのHOMEで、make disthack 
	   /etc/aliases に書くための include-disthack という見本が
	   生成される

	たうぜんのことながら ML-dist の防衛はMTAの設定なので各自頑張るように

   HTML: define default $HTML_INDENT_STYLE = 'UL';

	HTMLのスレッド表示をかえたざんす

1998/12/20
   base64decode.pl: enable binary mode IO (for NT)

   HTML 4.0: 822 unfolding in createing HTML articles.

   $NOT_USE_ESMTP_PIPELINING:

	PIPELINE が可能な場合でも使わない

1998/12/15
   makefml: fix sockaddr probe() code 

	this code bug is not found on a lot of plathome (just a good luck)
	but on redhat linux.

	インストーラのバグ
	redhat linux 以外ではたまたま顕在化しなかった(運)

1998/12/12
   $DISTRIBUTE_DUMMY_RECIPIENT: 

	If $DISTRIBUTE_DUMMY_RECIPIENT is defined in config.ph such as
		$DISTRIBUTE_DUMMY_RECIPIENT = "fml-dist\@$DOMAINNAME";
	In distribution of articles, fml sends it to only one address e.g.
	fml-dist. MTA (e.g. sendmail) sends the mail to members of the ML
	which are listed in $DIR/var/db/rcptlist
	 e.g. /var/spool/ml/elena/var/db/rcptlist.

	fml -> fml-dist -> (/etc/aliases)

	[Configuration Examples]

	$DIR/config.ph
	   $DISTRIBUTE_DUMMY_RECIPIENT = "fml-dist\@$DOMAINNAME";

	/etc/aliases
	fml-dist: :include:/var/spool/ml/elena/var/db/rcptlist

	$DISTRIBUTE_DUMMY_RECIPIENT が設定されている場合
	記事の配送時に fml は一つのアドレスにのみ送る。そのアドレスで
	:include:list などでMTAが本当のメーリングリストメンバーへ配送する。

	セキュリティ: そのアドレス自体を防衛するのはMTAの設定であり
	別途考えるべき課題である。

	また、この方法により複数のMTAによる並列配送などfmlの機能が使え
	なくなることにも注意。システム設定を複雑にしてでも perl の生存
	時間を短くしたいとという特殊な人向きの特殊機能。

1998/12/11
   admin command: fix 'put' command function to cut off 'admin' lines

   HTML: fix threading

	ちょっと微修正。またためしてみてね〜＞スレッド化

1998/12/5
   HTML: Try new threading algorithm ! (not default yet)

	$HTML_THREAD_REF_TYPE  = "prefer-in-reply-to";
	$HTML_INDENT_STYLE     = "UL";

   という設定でできるHTMLファイルのスレッド化をためしてみてね〜:) 

1998/12/3
   PIPELINING(RFC2197)

	最大の問題は sendmail が対応してないことだ…
	＃PIPELININGしてくれるやつはすでに十分速くSMTPで
	＃受けとってくれてるとおもうが、まぁさらにもう少し速くなると

1998/12/1
   HTML generator: cut off superflouous ^M

1998/11/26
   fix admin members/actives fails:
	modify return value of ProcFileSendBack()

1998/11/25
   append FYI how to get help for administrators 
	when admin command error occurs.

1998/11/23
   Documents: remove # (command trap keyword) in default.

   You can re-create help, welcome, ... 
	1. in "makefml config"
	2. makefml create-doc-template
	3. make doc-template in the ML HOME DIRECTORY

1998/11/22
   help file: add 'tgz' mode in digest mode (missed in the past???)

	まとめ送りの tgz モードがなぜかマニュアルからぬけてる;)

   MTI: negative cache to warn the burst traffic to maintainers

1998/11/19
   HTML article generator: fix thread 'UL' parenthesis

1998/11/18
   msend.pl: bug fix uuencoded name in the mode "tgz".

   HTML article generator: fix spool2html emulation code

	spool2html をつかうとヘッダに足らないものがあるのを修正
	＃ spool2html のfmlエミュレーションの修正

1998/11/17
   $MTI_TIE_TYPE: use "tie" function in MTI sub system.

	$MTI_TIE_TYPE に DB_File などを定義すると perl 5 の tie 
	を使った hash へのバインディングを行う。
	perl 4 では使えない(当り前:-) 
	使える引数はOSに依存する。各自マニュアルを参考に
	e.g. DB_File, NDBM_File, ...

1998/11/09
   install.sh: modify for SunOS (?)

1998/11/08
  +'ed user <addr+ext@domain> (for sendmail users):
	fix to permit this address syntax when automagic registration.
	but not fix to permit command with this addr beautifully.
	# so require more eloborate design

  +'d ユーザのアドレス体系を扱えるように修正
  e.g. MAR+KUN@DOMAIN :-)

  'status' command: consider $MSEND_MODE_DEFAULT variable

1998/11/07
   HTML articles: modify calling base64decode.pl for on NT4

   makefml menu: a comment on *HANDLER

1998/11/06
   %SECURE_REGEXP: oops, the code is inversed in the definition.
	The document style hash is correct. Fix it.

   admin.*pass.* command: back again to permit FML 2.1 level pass phrase 
	degree of freedom.

	リモート管理用のコマンドのパスワードに使える文字列をFML 2.1 の
	レベルに戻す。それ以外のコマンドは元のまま

1998/11/04
   install.sh: internal code changes

   irc: modify a lot

1998/11/03
   moderator: fix to remove Approval: field under $PASS_ALL_FIELDS is set.

   bin/emumail.pl: fix help message

   fix some documents

1998/11/01
   add bin/base64decode.pl

   HTML 4.0 article generator
	Fml uses bin/base64decode.pl as a default when $BASE64_DECODE
	is not defined.

	html 化をする際のBASE64デコーダのデフォルト
	明示的に $BASE64_DECODE を定義した場合はそちらが優先

1998/10/30
   EnvelopeFilter: ignore Email address patterns before check routine sets in.

1998/10/27
   USE_ENCRYPTED_DISTRIBUTION: check PGP signature before decoding

1998/10/26
   make secure: disable 'status' command

1998/10/24
   @DenyLibraryProcedure: more friendly message :)

   mead.pl: modified to work with perl 4

	perl 5 だと、ん〜ちょい変。なおす

   spool2html.pl: update documents and information (help message)	

	ちょっと表示やらドキュメントやらをなおす。-d -D のチェックを
	ちょっと親切化した(とおもふ)

1998/10/18
   daily.pl: bug fix initialization

1998/10/17
   @DenyLibraryProcedure: bug fix

   USE_ENCRYPTED_DISTRIBUTION: 

	define PGP Encrypted ML and prepare makefml menu entry

	makefml のメニューでPGP暗合化 ML モードへ移行できるように
	便宜上定義した。もちろん ML の鍵を作る、メンバーに配るなどの
	作業は別途必要なのは変わらない。
	理屈について詳しくは doc/op* を見てね

   fml.pl: $TZone = +0900 for old config.ph (compatibility)

   $NOT_USE_SPOOL: logs ARTICLE number when $NOT_USE_SPOOL is set.

   $SUBJECT_FORM_LONG_ID
	check $SUBJECT_FORM_LONG_ID < 2 or not for compatibility

	互換性のため「$SUBJECT_FORM_LONG_ID < 2 では動作が違う」を戻した
	makefml の menu を変更

1998/10/13
   fml.pl: bug fix to ignore plural caching in $USE_LOG_MAIL case.

	fml.pl で余計なキャッシュまで書いているのを修正
	ロック直後に処理を移動

1998/10/11
   daily.pl: rewrite to implement '-t trap_patfile'

	daily.pl [-hd] [-f patfile] [-t trap_patfile] [-p days]

	-h        this message
	-d        debug mode

	-f file   pattern file to ignore
	-t file   pattern file to trap (evaluated before ignore list)
	-p days   scan at which day (default is 1, that is "yesterday")

1998/10/10
   mead.pl (Mail Error Analyze Daemon);
	Ignore Japanese Strings (which may cause an error)

	日本語を無視(誤動作する)。可能性のある文字列を全部見て
	sort |uniq してキャッシュする(first match では user unknownが
	上書きされたりするかもしれないのを回避)

1998/10/8
   makefml: Installer asks you TIME ZONE (CFVersion 4.1).
	    We must require this for Internationalization.

	インストーラは TIME ZONE を聞きます。多分自動判定できるので
	一発余計にキーを叩いてちょ:) ちなみに日本は +0900 です
	#でも summer time は…どしよもないきがする

   documents: fix typo's

1998/10/6
   SUBJECT_TAG's 0 padding problem:
	remove strange constraints
	if $SUBJECT_FORM_LONG_ID < 2, redefine $SUBJECT_FORM_LONG_ID = 5;

   SUBJECT_FORM_LONG_ID:
	reflects the figure of sequence in X-Mail-Count: regardless of
	Subject: line.

   SUbject: にタグ (Elena:00100) などはつけなくても SUBJECT_FORM_LONG_ID
   は X-Mail-Count の 0 padding を制御するようにした
   ＃タグのあるときはそれも同時に変わっているはずですが、ないときも

   HTML GENERATION: using the distributed article header

   $MANUAL_REGISTRATION_TYPE: bug fix confiction with AUTO_REGISTRATION

   2.2A#1 ; DO NOT USE 2.2A#1's AUTOMATIC REGISTRATION 

1998/10/5
  HTML Generation: adjust DEFINE_FIELD_FORCED fields for html output.

	HTML生成で DEFINE_FIELD_FORCED を考慮する

  $DISTRIBUTE_SUMMARY_HOOK: defined

1998/10/4
   chaddr: check the new address and the current address similarity
	For example, unless this, sub-domain change must be an error.
	e.g. chaddr foo@a.b.x.y.z foo@123.b.x.y.z
	So, we gains the ADDR_CHECK_MAX if we encounters this case.
	And we need SaveACL and RetACL to get back to the
	original state after this function calling(like Context Switch).

	chaddr でサブドメインだけを変更しようとすると通常はエラーになる
	というのは変更先のアドレスがすでにメンバーリストにあるので。
	そのため

		chaddr foo@a.b.x.y.z foo@123.b.x.y.z

	のような時は、アドレスの似ている度合いを見て一時的に
	$ADDR_CHECK_MAX の値を上げることで正しく動作させる。
	これに伴い &SaveACL, &RetACL でこの関数呼び出しを
	保護する必要がある。HOOkなどで呼び出してる人は注意。

   makefml: bug fix do_ctladdr: off/on/chaddr/matome/digest command
	fix mis-configure which files to operate

   makefml: qmail setup fix umask of examples in group case.

1998/10/3
   $MANUAL_REGISTRATION_TYPE = 'confirmation' or 'forward_to_admin'

	How to handle 'subscribe' request to ML modified by
	maintainers' hand. In default fml confirms the will to From: address.

	手動で登録作業をする ML で、subscribe request をうけたら
	confirm を返し、confirm が帰ってきたら管理者は手で登録する。
	デフォルトは confirmation にしてある。＃ 2.2A

   %Procedure: 'l#command' syntax

	Restrict 'command' requests in one mail up to $Procedure{"l#command"}
	$MAXNUM_COMMAND_INPUT is another issue which restrict the
	total number of commands in on email.

	一通のメールの中のコマンド 'command' リクエストを最大でも
	$Procedure{"l#command"} 個までに制限する。コマンドごとに制限は
	変えられる。

	$MAXNUM_COMMAND_INPUT は一つのメールの中のコマンドの合計への制限
	になっている(種別を問わず足し合わせた値)。

1998/10/2
   bug fix: installer permission adjusting problems

1998/10/1
   mead.pl -k command option (default 'bye')

	If you 'off' the users who causes "unknown user" error "not reachable",
	you can  use '-k off' option.

	-k off とすると(デフォルトではユーザを自動的に抜いてしまいますが)
	それを OFF の状態にします。

98/09/27
	2.2 RELEASE

98/09/20
	bug fix 'actives' 'members' in 'automatic registration'
	bug fix ntfml.pl listname-ctl case (consider null $CONTROL_ADDRESS)

98/09/18

	remove 'addr' command

	[2.2BETA#27]
	bug fix 'chaddr' (mis-patched by fukachan , sorry > fukui)

98/09/04
	[2.2BETA#24]
	add ANNOUNCE_MAIL_SIZE_OVERFLOW for "message/partial" case
	# n == 1 の時だけさらしものにします(そうしないと怒涛のさらしが…;-)

	[2.2BETA#23]
	add ANNOUNCE_MAIL_SIZE_OVERFLOW
	でっかいめーるをなげると ML でさらしものにされてしまう:)
	＃でふぉーるとは使わない

	etc/makefml/Makefile; remove $(PWD) (of no mean)

	add menus in "makefml config"	

	SECURITY_AND_FILTER -> ANNOUNCE_MAIL_SIZE_OVERFLOW
	OPTION -> HTML_GENERATION -> HTML_INDEX_UNIT
	OPTION -> HTML_GENERATION -> HTML_INDEX_UNIT -> TIME_RANGE
	OPTION -> HTML_GENERATION -> HTML_INDEX_UNIT -> NUMBER_OF_ARTICLES

98/09/02
	makefml; 余計な処理を整理する
	＃βのテストをしてくれてる方へ; makefml のそれぞれの操作で
	＃cf の STRUCT_SOCKADDR がちゃんと定義されてるのを確認してみて下さい

98/09/01
	bug fix: 
		crypt() in FreeBSDでcryptな場合のみ
		ADDR_CHECK_MAX >= 10 の時の判定ミス

	まぎらわしいのでドキュメントの version をやめる	
	＃package version ではなく作った時の version になっている 

98/08/30
	[2.2_BETA#18]
	bug fix: X-ML-Info (to maintainer case) 
	ntfml.pl: add sleep(1) before &Arrange*Proc();

98/08/29
	msend.pl -s (slow start) オプションをつけると
	スタートをゆっくりにする。
	複数の ML がある場合には msend_master.sh を使うと良い

	crontab の見本生成で起動する時間を乱数で少しふる
	(msend の slow start の補助)

	msend_master.sh (見本)を作ってみる。ようするに
		for ML (@ML) {
			msend for ML
		}
	するだけのスクリプト

98/08/27
	improve INSTALL まにゅある(２、３の注意点)
	msend.pl のスタートをゆっくりにする。
	(乱数で最大3分以内のsleepをして待ってみる)
	本当は crontab をちゃんとずらして設定しないといけないが
	しない人がいそうなので

98/08/24
	improve Message-ID cache
	fix warning unless effective commands.

	ん〜 今日あたり 2.2 release のはずだったんだけど;_;
	とりあえず one week 延期

	2.2 BETA#14

	liblop.pl: pull down to 2.2BETA#12
	summary 分割送りなおし問題の修正

	2.2 BETA#13
	makefml newml; modify to append 'LOCAL_CONFIG' to $DIR/cf
	since makefml did not do this to avoid duplicated LOCAL_CONFIG.

	fix summary split problem
	(anyway, may fix again it by more elaborate way)

98/08/18,9
	re-configure doc/html/
	update index.html in both a package and http://www.fml.org/fml/

98/08/17
	fwix.pl; fix to that .toc works

	I think 2.2 IS READY FOR RELEASE. 
	NOW WE OBSERVE THIS VERSION A LITTLE.
	THOUGH DOCUMENTS CLEAN UPS MAY CONTINUES ... ;-)

	upgrade/clean ups documents
	English translation of "help" file.

98/08/16
	help と help.eng を融合する(編集の前にとりあえず合体)
	# by Jason.Chen@efi.com's Translation (95/11)

	update documents ... (はつづくよ、どこまでも ;_;)
	あとは help だけか？

	bug fix; listname-ctl への guide もちゃんとうけつける
	(#guideだけでなく)

	英語モードのバグふぃっくす

98/08/15
	update documents, makefml config menu 
	のこりは README help

	makefml -U install は lock なしにインストールを実行

98/08/14
	bug fix libarchive.pl

98/08/13
	member_name.wix を書く、英訳する。include する
	doc/ri/FILES を改良

98/08/12
	・actives/members ファイルのバックアップ: .bak => .0 =>.1 

	$AMLIST_NEWSYSLOG_LIMIT	(default 50*3000 = 150K bytes)

	・ログファイル($DIR/log)の turn over

	ログファイルがある大きさを越えたら log -> log.0 -> log.1 のようにずら
	していきます。大きさの基準は次の変数にいれます。

	log -> log.0 -> log.1 ...

	$LOGFILE_NEWSYSLOG_LIMIT (default "")

	update FILES (Hiroshi NAKATA <hnakata@cc.gunma-u.ac.jp>)
	modify makefml (perl4 case)

	NT4: bug fix libexec/popfml.pl

	fix typo: MAXNUM_COMMAND_INPUT

98/08/11
	bug fix makefml lock (not flock) algorithm
	bug fix libexec/mead.pl cache

	NT4 port: ActivePerl で動くように修正(したつもり)

98/08/09
	2.2BETA は10日〜2週間程度の予定です。
	特別な問題がない限りこの形が 2.2 になります。
	(一部のドキュメントはまだ修正します)

98/08/09
	2.2BETA

	add NOTIFY_MAIL_SIZE_OVERFLOW (default 1)
	巨大なメールが送られた時は送り主にはその旨を伝えるべきである
	(経験的には)そうでないと2度3度と送ってくるものだから。
	なお message/partial の時は n==1 の時だけ返事を返す
	(そうしないとメール爆弾の応酬合戦になってしまう)

98/08/07
	○ [デバッグ用途]
	最近fmlが受けたメールを保存する(デフォルトは NO, 使わない)
	投稿、コマンドは問わずに保存。

	(stdinlog のかわりに使えるよね？)
	最近 $NUM_LOG_MAIL 通のメールの先頭2048バイトを $LOG_MAIL_DIR 
	($DIR/var/Mail) に保存する。各ファイルのサイズの上限は
	$LOG_MAIL_FILE_SIZE_MAX bytes。このくらいあればヘッダとメール
	の最初の方は十分収まるのでデバッグには十分だろう。
	101通めは1を上書きするなどのようにファイルは円環上に使用される
	(このために各 ML 、平均１Ｍ程度のディレクトリが必要になる)

		LOG_MAIL_DIR:	$VAR_DIR/Mail
		LOG_MAIL_SEQ:	$LOG_MAIL_DIR/.seq
		NUM_LOG_MAIL:	100
		LOG_MAIL_FILE_SIZE_MAX:	2048

	○ $USE_DOT_QMAIL_EXT: (qmail 使用時)

	コマンドの - が使えないので
	elena-mget--1-3-mp@DOMAIN 宛のメールを
	"mget 1-3 mp" コマンドと解釈するようにする

98/08/06
	フィルタリングコードの改良

	members, actives ファイルのバックアップが大きくなったら
	自動的に newsyslog をかけて var/log/ へまわす。

	ユーザ用の actives members コマンドでは
	ヘッダやコメントやすでにいない人などを省略する。
	管理者用コマンドでは今までどおり省略はしない

	hack query "number", "string" type of makefml

98/08/04
	clean up, fix documents
	コマンドのalias 
		undigest	-> digest 0
		unmatome	-> matome 0

98/08/02
	sbin/makefml: $CPU_TYPE_MANUFACTURER_OS キャッシュ

	$AMLIST_BACKUP_TYPE: rcs
	もし未定義なら従来どおりの方法で .bak ファイルが作られる。
	RCSの場合も作成されるが .bak には一番最近の状態のものがあるだけ

98/08/01
	mead.pl
		user unkown などの単語でも解析する
		user unkown を 1 それ以外は 0.25 に値を変更する。
		-p オプションで変更する。

	○ Solaris と NT4 の人だけ
	   sys/arch/ を廃止して sys/ の下に統一しました
	   インストールして何かあったらいって下さい。

	* HTML 生成コードを少し改良   

98/07/31
	makefml -f /usr/local/fml/.fml/system install
	とかやったら入力を促さない
	再インストールやパッケージなどに便利か？

	FieldCapitalize(); X-ML- は X-ML-
	e.g. X-ML-Info が上書きできない(X-Ml-Info に変換しちゃうから)のを修正

98/07/27
	INSTALL ファイルを 2.2 用に奇麗にする。
	その他奇麗に作業…
	rename $BASE64ENCODE $BASE64_ENCODE (libfop.pl)
	cf に定義

98/07/26
	$USE_DOT_QMAIL_EXT: qmail 使用時
	listname-command をエミュレーションする

98/07/22
	某サーバからの返事らしきもの？は弾く
	$REJECT_ADDR .= '|\S+\-suscribe|\S+\-unsuscribe|\S+\-help';

98/07/21
	bug fix mis-preservation of the comment word
	in files when "chaddr" command

98/07/19
	英訳作業(2nd check): 終了したもの
		doc/op 
		drafts/ の下(helpを除いて)

	INSTALL_on_NT4 の再構成/update/英訳

98/07/15
	modify lock code on WINDOWS NT4
	これで謎の config.ph size 0 問題が回避できるか？
	回避できたぽいぞ？ためしてみてね〜

	fix "index" search algorithm
	fix MTI code a little more friendly?

98/07/10
	fix typo msend.pl _o_

98/07/06
	modify mkdirhier against perl4 bug?

98/07/05
	Change "search site*ph " code to use SearchFileInLIBDIR
	bug fix CPU_TYPE * check for solaris2
	define &ATOI() to expand 2M -> 2*1024*1024
	define &FieldCapitalize to capitalize reply-to to Reply-To
	enhance COPY_FIELD to handle  both subject and Subject

	makefml config の security menu を増やした
	zip mode: should check $ZIP existence 

98/07/04
	enhance &COPY_FIELD(), 
	add &ADD_FIELD() operation to &DEFINE_FIELD_* 
	modify message-id duplication check range over all ID caches
	add $MESSAGE_ID_CACHE_BUFSIZE (default 50*100);

98/06/30
	sysv4 == solaris2 ということにする:)
	config.guess を新しくする, NEC4800でばぐるのもなおす
	add /usr/ucblib to search_path for EWS4800

98/06/28
	ファイル操作(get,mget,msendなどからみ): 
		圧縮操作関数とencoding操作関数を分離する  

	ファイル操作に zip モードを加える (test phase)

	confirm: subscribe などがにほんごだったら日本語だとちゅういする

98/06/27
	moderator: duplication check code for test

	fix confirm key generation 
	fix $REGISTRATION_ACCEPT_ADDR to work in "admin subscribe"

	福井さんぱっちをあてる: Masayuki FUKUI <fukui@sonic.nm.fujitsu.co.jp>

	○ admin モードでなければ、自分 ($From_address) 以外のメンバーを
	   old-addr に指定して chaddr することはできない

	○ new-addr が既にメンバーとして登録されていたらエラー

	○ '# bye' '# admin bye' のときも、bye するメンバーがメンバーかどうかを
	   最初にチェック

	○ '# admin bye' のとき、bye の対象者にも mail を送るようにした。

	○ '# chaddr' '# admin chaddr' のエラーチェックにひっかかったとき、
	   無条件に 管理者, old-addr, new-addr に通知 mail を送っていたのを、
	   関係ありそうな人にだけ通知 mail を送るように変更

	○ libmember_name.pl
		'unsubscribe-confirm' コマンドに対応した。

98/06/20-23
	タイムアウト関係の bug fix, parameter の tune

	MEAD (Mail Error Analyzer Daemon)
	エラーメールを解析して自動的にユーザを削除
	これにあわせて makefml newml 時のサンプルに例を付け加え
	MEADまわりの minor bug fix

	sys/arch/WINDOWS_NT4
		IDLE_PRIORITY で呼び出す
		POP verison: デフォルトのループの時間を180秒に

	fix synchtml warning condition (case of no html directory)

98/06/19
	HTMLスプール: http:// 自動変換 bug fix

	spool2html; not fork() on NT4

	confirmd; bug fix not "chdir $DIR"

	msend.pl
		fix MSEND_MODE_DEFAULT to be effective

	libra.pl
		bug fix plural chaddr requests in one mail

	doc/ri/INSTALL.wix
		Add /usr/doc/fml/ on Debian

	doc/ri/INSTALL_on_NT4.wix
		http://member.nifty.ne.jp/~ssk/download.html

	fml.pl
		change calling of Notify to &Notify().
		bug fix COPY_FIELD (plural lines of a field)
		bug fix boundary= (boundary=".*" not \S+)
		fix ADD_FIELD to check the uniqueness of fields
		COPY_FIELD: ADD_FIELD is added
		&MOVE_FIELD(old-field, new-field)

	e.g.
		&MOVE_FIELD('Subject', 'X-Original-Subject');

98/05/26
	fix libsynchtml.pl

98/05/25
	change: mkdir -> MkDiHier or Mkdir (SNAP file)

98/05/24
	add UNSUBSCRIBE_AUTH_TYPE to the menu of "makefml config"
	ispell check over doc/smm/
	bug fix unsubscribe confirmation

98/05/22
	import jcode.pl-2.6
	"admin remove-article" command:
		handle to remove html articles at the same time.
	clean up and add on MetaInfo (INSTALL_on_NT4)

98/05/21
	bug fix "makefml matome"
	bug fix bin/fwix.pl Japanese conversion for plural lines in a buffer
	makefml logs installing in e.g. /usr/local/fml/.fml/log

98/05/14-20
	2.1C#27

	fix "accept local-part recipients" im smtp routine
	but "not accept local-part only" in automatic-registration
	bug fix "confirmation mode" 
	documents updates

	もろもろ

98/05/13
	add addr-spec check mechanism for the argument of RCPT:

98/05/11
	modify bin/fwix.pl to import jcode.pl within it.
	change *_TEMPLATE default

	&DEFINE_FIELD_PAT_TO_REJECT(ヘッダフィールド, 正規表現)
	例: Subject: に ADULT XXX のいずれかの文字列が入っていたら
	SPAMとみなして捨てる

     	&DEFINE_FIELD_PAT_TO_REJECT('subject', 'ADULT|XXX');

98/05/08
	bin/fwix.pl: special character conversion

98/05/01
	bug fix makefml lock

98/04/30
	ADMIN_ADD_SEND_WELCOME_FILE "admin add" で $WELCOME_FILE
	を送る(default はしない)
	HTML_INDEX_UNIT: 'none' -> 'infinite'

98/04/24-29
	new handler type: auto_asymmetric_regist
	fml.css path auto-adjustable and typo fixed(libsynchtml.pl)
	etc/makefml/menu.conf: add "auto_asymmetric_regist"
	fml.pl, fml_local.pl: fix typo
	fml.pl: add "auto_asymmetric_regist"
	libsynchtml: expiration when HTML_INDEX_UNIT eq 'none' case

	several document upates, English translations (continued)

98/04/23
	add $HTML_THREAD_REF_TYPE 
		default
		prefer-in-reply-to

	bug fix &SyncHtml thread link sequential duplicaton
		but not unique on different thread lines
	bug fix typo: sbin/makefml, doc/drafts/help.*

98/04/16-98/04/22
	bug fix makefml
	add "makefml command"
	add $HTML_THREAD_REF_TYPE (available in makefml menu)
	add controller by service menu ? (NT Version)
		ntfml.pl
		ntfml.cmd
		ntfmlrm.cmd
		autoexnt.bat
	fix MIME/Multipart bug (may be in the case of "library get")
	move non-used user defined variable to global name space
	with corresponding to fixing documents

	several document upates, English translations (continued)

98/04/15
	buf fix "matome" command; how to reset msendrc.

98/04/14
	bug fix "makefml matome"

98/04/13
	makefml matome,on,off,chaddr,digest
	add diagnosis to cf/config ()
	#fml-support: 04205; Masayuki FUKUI <fukui@sonic.nm.fujitsu.co.jp>

98/04/12
	buf fix remote administration authentication bug 
	(appears in perl 4.036. why?)

98/04/11
	add $DATE_TYPE
	apply HTML 4.0 patch
	add stylsheet sample generation by html generator routine

	add $REGISTRATION_ACCEPT_ADDR, which is applied for both cases,
	automatic or manual adding a subscriber.
	(obsoletes $AUTO_REGISTRATION_ACCEPT_ADDR (works for compatibility))

	$SUBJECT_TAG_TYPE: [ID], (ID)
	newsyslog does not show skip (debug) message

	change 'mget' and 'get' error message

98/04/01
	bug fix, clean up, update a few documents (for English translation)

98/03/23
	apply a patch to fix libmember_name.pl and libfml.pl
	  ・fix arguments of Admin*
	  ・$USE_MEMBER_NAME 有効時の admin members コマンド対応
	  ・admin members & actives コマンドで、送り返すファイル名を
	    %AdminProcedure から参照せずに %Procedure から参照している
	    バグ(?)を修正
	[From:    Masayuki FUKUI <fukui@sonic.nm.fujitsu.co.jp>]

98/03/22
	bug fix loading bug of spool2html.pl

	$AUTO_REGISTRATION_ACCEPT_ADDR
	特定のアドレスに対してのみ自動登録を認める場合に便利
	perl の正規表現で書くこと (case insensitive)

	e.g.
	   $AUTO_REGISTRATION_ACCEPT_ADDR = 'domain.co.jp';
	   $AUTO_REGISTRATION_ACCEPT_ADDR = 'domain1.co.jp|domain2.co.jp';

98/03/19
	Multipart の最初のブロックだけを subscribe やフィルタリングの
	対象にする(たとえ下らない写真とかついてるMultipart で中身が 
	subscribe 一行だけのメールでもそれをはじく/登録に使うため）
	handle multipart paragraph for filtering and subscribe
	bug fix Message-ID caching
	bug fix conservation of $From_address in libmoderated.pl

98/03/18
	enhance sbin/makefml guess on your system
		if config.guess fails, makefml waits for your input
		If we cannot guess your system, unknown-unknown-unknown:D
	bug fix sbin/makefml lock

98/03/14
	2.1C (2.2 ALPHA)
	Prepare fully Japanese and English support

	'bye' / 'unsubscribe' with confirmation (ALPHA TEST)

98/03/12
	bug fix "makefml newml" on NT4 (cut off to generate qmail examples)

98/03/09
	define 'lhaish' for 'mget', 'digest', 'matome' commands

98/03/07
	doc/op の2か国語化 α版
	(ispell check'ed)
	# 2か国語化の難所が終ったので、もうじき 2.1C でしょう。
	# (事実上 2.1C == 2.2ALPHA)

	bug fix;
	hack する人への注意: 管理者用のコマンドの argument を
	一般ユーザ用コマンドの関数とあわせました。
	($proc, *Fld, *opt, *e) => ($proc, *Fld, *e, *opt)

	$MAXNUM_COMMAND_INPUT が定義されている場合、一回のメールで使え
	るコマンドの個数の上限。もし未定義なら無限大:)

98/03/04
	bug fix moderator mode type II's header fields config

98/03/03
	$HTML_HEADER_TEMPLATE があれば html な article を生成する時
	そちらを優先する。

	--------------------------------
	$HTML_HEADER_TEMPLATE 

	メール本文
	--------------------------------

	例: $HTML_HEADER_TEMPLATE  = q#Subject: $e{'h:Subject:'} #;

	qmail 用の見本も makefml newml <ML> で生成

	library コマンドの数を減らす(実装上増やすのはちょっと待った〜)
	@DenyLibraryProcedure

	モデレーターモードの配送メールのヘッダ設定
	@ModeratedHdrFieldsOrder

	add $PCurrentTime
	bug fix &GetTime and compatible modes

98/02/23
	bug fix confirmation mode (set to ignore Reply-To:)
	bug fix matome/digest command when $NOT_USE_SPOOL is set.

98/02/20
	* confirmd "confirm daemon" BETA TEST

98/02/17
	INSTALL_with_QMAIL; qmail の場合についてのメモ

98/02/16
	2.1B #2

	* confirmd "confirm daemon" ALPHA TEST
	  定期的に「これからも ML に入り続けるか？」を尋ね
	  返事がないならそのメンバーを削除する。
	  まとめ送りと同様に cron から起動する。

	* makefml ML::command syntax
	* fix moderated type II and html geneartor

98/02/11
	2.1A final is 2.1A#45 and define 2.1B 

      * 2.1B
	デフォルトでこれらの変数(2.1Aではテスト)を
	    $MIME_EXT_TEST = 1;
	    $FOP_HACK = 1;
	    $USE_MTI_TEST = 1;
	ON にしています(この三箇所以外は 2.1A#45 と同じ)。
	これらの変数をONにしてちゃんと動くかどうかのテストしてほしいですが
	もしうまくいかない/安定性を重視するなら 2.1A final のほうが
	よいでしょう。 

98/02/01
	$MODERATOR_FORWARD_TYPE III

98/01/25 (01/21 - 01/25)
	English translation in doc/smm (now 80% complete?)
	modify EnvelopFilter' hook code for perl 4
	remove $ML_MEMBER_CHECK to replace 
	&AutoRegistrableP and &NonAutoRegistrableP
	cut off Re[\d+]: Re^\d+: in Subject:
	bug fix config.guess search of makefml

98/01/21
	makefml SECURITY section

		&COPY_FIELD(field, new-field);
	Example:
		&COPY_FIELD('Sender', 'X-Sender');

98/01/20
	rename: compatible なのでどっちでもOK
		$REJECT_DISTRIBUTE_FILTER_HOOK -> $DISTRIBUTE_FILTER_HOOK
		$REJECT_COMMAND_FILTER_HOOK    -> $COMMAND_FILTER_HOOK

	$FILTER_ATTR_REJECT_COMMAND
		$USE_DISTRIBUTE_FILTER 時に "# command" も弾く

98/01/19
	bug fix: sbin/makefml add_user, time

	$FOP_HACK (将来なくなるん
	   mgetのPLAINTEXTでヘッダ部分をMIME Decodeする

	command reply に References: をつける

	import patch for libmember_name.pl

98/01/17
	add "makefml lock <ML>"

	* on NT
	ntfml -u LOOP_UNIT
	system() argument hack (just one line hack, enough?) 

98/01/15
	bug fix getting passwd of popfml.pl

98/01/14
	MTI

98/01/11
	2.1A#28

	Mail Traffic Information (MTI) beta test phase
	"admin unlink-article" command (unlink only)	
	add "clean up temporary file" in pgp's PGPDecode2
	which was forgotten 2.1A#27

98/01/10
	libmember_name.pl を import しました
	(contrib/localhack/release-2/member_name/)。
	Author: Masayuki FUKUI <fukui@sonic.nm.fujitsu.co.jp>

	--- README より抜粋 ---
	libmember_name.pl は、その問題を解決するために、各メンバーの名
	前 (基本的には、mail の From: ヘッダに書かれている名前(gecos)) 
	を管理する機能を付加します。
	…以下略…

	CONFIRMで返すフレーズの改良
	drafts/confirm も改良

	"admin put" bug fix
		return status
		PGPモード

	amctl functions workd for $ADMIN_MEMBER_LIST when admin mode.

98/01/07
	2.1A#26
	bug fix %ExtProcedure, add %ExtAdminProcedure
	extend SecureP (for command mode)
	Mail Traffic Information (MTI) beta phase
	$AUTO_REGISTRERED_UNDELIVER_P まわりのコードを意味論的に正しくする

98/01/06
	import examples of mnew ML 
	$FML_PACKAGE/contrib/localhack/release-2/mnews

98/01/05
	2.1A#25
	moderatorsへのメールの unix from 削除
	some clean up
	Update Copyright

97/12/26
	2.1A#24
	Mail Traffic Information (MTI) alpha
	＃αなので使うには覚悟がいるぞ:)
	＃変数名は後で変わるかも知れない

	MTI の番外編

	   $USE_MTI = 1;
	   $MTI_EXPIRE_UNIT = 3600; # 秒数

	$MTI_EXPIRE_UNIT 内に流れたメールの量の最大値を

	$MTI_DISTRIBUTE_TRAFFIC_MAX	(配送)
	$MTI_COMMAND_TRAFFIC_MAX	(コマンド)

	のように設定します。トラフィックがこの値を越えると reject する
	ようになります。$MTI_EXPIRE_UNIT 後には再び投稿できるようにな
	ります。このアドレスを spamlist ($REJECT_ADDR_LIST) に自動的に
	追加するには $MTI_APPEND_TO_REJECT_LIST = 1;

97/12/14
	2.1A#21
	メンバー最大値チェック(自動登録)
	$MAX_MEMBER_LIMIT

	配送メールのフィルター
	$USE_DISTRIBUTE_FILTER
	$REJECT_DISTRIBUTE_FILTER_HOOK
	$FILTER_NOTIFY_REJECTION

97/12/07
	2.1A#20
	Commit English Translation Documents (no time, 1/3 completes ;_;)
	fix %MAP_DB libexec/fmlserv.pl
	bug fix Date: Lines: (fml.pl)
	modify injection codes to confirmation codes

97/11/29
	PGP decoding をBLOCKごとに実行
	    必要ならパラレルにBLOCKごとに暗号化処理
	HTML の第2階層にTOPレベルへのポインタを入れる(fml-support: 03451)
	PERMIT_COMMAND_FROM moderartors の処理を変更し
	    コマンドの承認？をできるようにする(嬉しいか???)
	    文字どおりの意味になったといえばそのとおりだが…

97/11/28
	フィルタリング:
	unsubscribe だけとか 空のボディ などを reject する
	カスタマイズは HOOK で呼び出すことにする

97/11/25
	$SMTP_SORT_DOMAIN	smtpfeed ある今限りなく無意味（苦笑）
		配送リストをソートしてからSMTPで配送プログラムへ渡す。
		人それを bulk_mailer のようなものともいうが…(ちと違う)

97/11/24
	add site_init.ph loading code; hence now we evaluate 
	in the following order: site_init.ph config.ph sitedef.ph

97/11/23
	2.1A #19	ntfml での まとめ送りの bug fix

97/11/22
	2.1A #18	ntfml での まとめ送りの bug fix

97/11/21
	2.1A #17	remove popfml queue_dir debug code

97/11/20
	2.1A #16	fix FreeBSD crypt(3)
			fix ntfml.pl queue_dir

97/11/10
	2.1A #14
	New NT POP Version (not MetaInfo version)
	several fixes
	new moderator mode

97/11/03
	新しい moderator モード ($MODERATOR_FORWARD_TYPE == 2)
	$MODERATOR_FORWARD_TYPE = 2 をデフォルトにする

97/11/02
	msend.pl timeout bug fix
	define $MODERATOR_FORWARD_TYPE, $MODERATOR_MEMBER_LIST
	$SLEEPTIME のデフォルトを 60 へ (いままでは 300)

97/10/30
	smtpfeed direct 呼びだし support α版

97/10/27
	2.1A#9
	fix typo of makefml (2.1A#8)
	bug fix "subscribe" buffer passwd to the Auto Registration Routine

97/10/25
	makefml config にヘッダ設定の部類を加える。
	Subject: の選択はここに移動。
	define $REWRITE_TO (I obsolete $NOT_WRITE_TO).
	0	original  の To: のまま (2.1A default)
	1	To: $MAIL_LIST, $MAIL_LIST以外のアドレス(2.1 Release)
	2	常に To: $MAIL_LIST (大昔）

	1と2はメールを読む時にどこの ML のメールか見易いように
	To: $MAIL_LIST が常に同じ位置に来るようにするためのもの。

97/10/23
	add %ExtProcedure to libfml.pl for the extension
	add $Fld as the original string  (libfml.pl)

97/10/14
	MetaInfo Sendmail 2.x on NT 用のコードを作る (arch/NT4)
	インストーラーが途中で MetaInfo かどうかきくのでそこで分岐して下さい
	MetaInfo version αテスト

97/10/11
	もし help ファイルなどがない場合は 
	install先/drafts/help (install 用の original テンプレート)
	をその都度各 ML にあわせて convert して送り出す。
	１ テンプレートをいじれば全 ML に反映される
	という半面
	２ 各 ML ごとに helpやguide に懲ることが難しい。
	懲りたければ書く。そうでないならデフォルトを使うなどができる
	だろう(ISP向けともいえる）
	なお makefml newml 時デフォルトではhelp, guide などは作成される

97/10/10
	fml.pl:
	   define $UNISTD (1 on unix, 0 on NT)
	   improve GetFieldsFromHeader

	libexec/fmlserv.pl: clean up
	proc/libutils.pl: &system bifurcation following UNISTD

97/10/08
	define $UNISTD
	fix the split codes for on Unix and on NT

97/10/06 (summary of changes between 97/09/21 and 97/10/06)
	new Parsing code (fml.pl libkern.pl)
	   especially for $INCOMING_MAIL_SIZE_LIMIT
	   notify code is in newly created liberror.pl

	add &RunStartHooks (fml.pl) as split name space of start hooks
	improve &Append2 error message

	add the exception code ctl:smtp:stdin2socket (libsmtp.pl)
	   when incoming mail size overflow

	Q decoding is on in default now (libMIME.pl) 
	fix notified recipients when chaddr (libamctl.pl)
	fix Header Field for &DEFINE_FIELD_FORCED
	fix &StdinLogMode to use &RunStartHooks (split name space)
	fix &AppendMimeDecodedSubjectMode to use &RunStartHooks
		(split name space)

	fix the trap ISO-2022-JP -> =?ISO-2022-JP? for MIME

	fix trap keywords for "chaddr" (libra.pl) 
	   (chaddr's keywords is not included)

	apply the patch (fml-support:03234) to libsynchtml.pl
	    top dir's {index,thread}.html in $HTML_INDEX_REVERSE_ORDER

	fix &ChAddrModeOK (libutils.pl)

97/09/21
	fix mci:mailer = prog (bug of perl?)

97/09/20
	impreove mget file search algorihtm
	fix ARCHIVE_DIR problems
	improve adjustment after loading configuration files 
	remove not used Define* functions (libutils.pl)

97/09/17
	fix http conversion: special chars, http:// syntax 
	use ">> var/run/flock" on solaris2 if $USE_FLOCK = 1;
	bug fix rehash problem in "matome 0"

97/09/16
	define the current as 2.1A

97/09/14
	fmlserv.pl 
	   remove majordomo compat code (not used now)
	   improve memory allocation

97/09/13
	fix append:files code 
	contrib/mail2irc :-)

97/09/08
	fix fmlserv when confirmation mode of auto registration
	fix duplicated return of "mget" when
		articles in spool and archive are duplicated.
	fix loading error of libsynchtml.pl (fix pl3)

97/09/07
	cut out the unix from in ForwMail (forwarding)
	since MH cannot handle unix from in the spool

	fix the help message reply when the invalid commands inputs

97/09/03
	comment out owner- syntax in etc/makefml/cf
	improve input without unixfrom.
	fix libexec/fmlserv.pl sitedef.ph evaluation
	fix libamctl.pl for $AUTO_REGISTERED_UNDELIVER_P

97/09/02
	bug fix fmlserv.pl Name Space Syntax

97/09/01
	fix typo doc/INSTALL
	$SUBJECT_TAG_TYPE = "[]"; => Subject: [Elena] test
	$SUBJECT_TAG_TYPE = "()"; => Subject: (Elena) test

97/08/20
	2.1 REL patchlevel 1
	fix "make doc" 
	fix fmlserv/config.ph template

97/08/19
	FML 2.1 RELEASE (post the announce to fj.sources)

97/08/18 <-> 97/08/03

	upgrade README and README.English
	modify check limit when user both archive and expire.
		FML claims that expire_limit > 2 * archive_unit 
	bug fix automatic html generation
	bug fix pgp auth type (libra.pl)
	bug fix md5 auth type (libra.pl and makefml)
	do not add fmlserv against loop
	bug fix libra.pl
	add -w to makefml for "makefml -w config" interactive mode (NT)
	bug fix bin/fwix.pl for English mode 
	add commands "subscribe" and "confirm" for auto_regist mode
	bug fix etc/makefml/menu.conf
	upgrade and bug fix documents
	ifdef bifurcation for UNIX and NT4

	--- FML 2.1 RELEASE TEST PHASE ---

97/08/03
	*clean up several files (for FML 2.1 RELEASE)

	add %SECURE_REGEXP to fml.pl
	update crosspost code (libcrosspost.pl)

	add &WholeMail $title extension
	add ifdef branch fo win32 extention

	when auto_regist, touch "actives_is_dummy_when_auto_regist" file.

	check $ENV{'OS'} to determine whether UNIX or NT.

	bug fix msend.pl
		bug fix -d && push LIBDIR 
		modify rename() check code for NT
		since rename(a, b) fails on NT if b exists
		though it is O.K. on UNIX.

	modify flock (fml.pl)
		use $DIR/config on open(DIRECTORY) OS

	libsmtp.pl
		bug fix $Current_Rcpt_Count

	$CryptNoEncryptionMode (libcrypt.pl, for makefml NT mode)

97/07/27
	REAMDE
	new crosspost code

97/07/26 - 97/07/20

	FML 2.1 Release Preparation; (final check phase)

	[fml.pl] $REJECT_ADDR_LIST spammers -> spamlist to adjust CF.

	Date:    Mon, 21 Jul 97 12:51:52 
	Modified files:
		proc/libsynchtml.pl
	Log Message:
	NEW EXPIRATION ALGORITHM:
	    When the thread is used, to expire one file is difficult.
	    It is too difficult to adjust the relations of thread regenation.
	    Hence we remove whole the sub-directories in which 
	    all the files are expired. WE DO NOT REMOVE EACH FILE.

	  1 Check all files in the directory (e.g. htdocs/19970721)
	  2 If all should be expired, rename directory -> directory.expire
	  3 htdocs/{index,thread}.html is reconfigured
	    ignoring *.expire directories.
	  4 after this, *.expire directories is of no use.
	    So, we remove them in the future or now:) slowly.

	[proc/libsynchtml.pl]
	HTML_EXPIRE -> HTML_EXPIRE_LIMIT
	real removing code of expired directories

	[fml.pl]
	x-mlserver field modified
	check $MALI_LIST eq $CONTROL_ADDRESS to adjust X-MLServer.

	[sbin/makefml]
	makefml edit command
	pgp:
	if group-writable, chmod 660 etc/pgp/pubring.pgp

	[proc/libcompat_cf2.pl]
	$HTML_EXPIRE_LIMIT adjustment

	[cf/MANIFEST]
	html generator default config
	HTML_DIR
	AUTO_HTML_GEN

	[bin/emumail.pl]
	-f -s options

	[bin/fwix.pl]
	error message
	.fig expansion

	[bin/spool2html.pl]
	$SleepTme
	-E (HTML_EXPIRE_LIMIT) option

	[fml.pl]
	Rcsid post only from "who" format

	[fml.pl]
	Log Message:
	ignore handler

	[cf/MANIFEST]
	LOG_CONNECTION = 0 (default)

	[fml.pl]
	subject tag fix (not calling libtagdef)

	[proc/libutils.pl]
	remove debug code of template substitute

	[proc/libsynchtml.pl]
	Log Message:
	expire 
	when expired and error founded, we regenerate index.html subdir/index.html
	hack for spool2html.pl

	[sbin/makefml]
	test ML (help message) fixed
	help -> do_info not do_help
	arguments and ml existence check added a lot

	[proc/libsynchtml.pl]
	HTML_EXPIRE_SCAN_UNIT
	skip index.html thread.html when scan directory to check expire or not

	[sbin/makefml]
	define reverse-y-or-n type for NOT_USE_SPOOL query
	delete policy operations
	add a lot of logging
	redefine FLushLog using code
	add Log Code (import fml.pl to here)
	$CONFIG_LOG -> $MAKEFML_LOGFILE
	flushlog only if logfile =~ /tmp/ (tempolary)
	mkdir spool for flock when newml
	flock bug fix ($mldir/$ml/ -> s#$ml/$ml#$ml#;)

97/07/20
	FML 2.1 DELTA based on config.ph CF Version 3
	a log of codes and documents updates for config.ph CF Version 3
	new html expire code 

97/06/27
	admin forward

97/06/21
	admin log を tail -100 log のようにする。

	... documents いろいろ ...

97/06/08
	Expire 機能の built-in 化
	USE_EXPIRE	1 (0 がdefault)
	EXPIRE_LIMIT	数字days(日数)か数字(記事の数) default は 7days
	cf/MANIFESTも変更

97/06/07
	%FmlExitHook (internal use)
	expire mode (defult is '7days')
		$EXPIRE_LIMIT = e.g. "7days"(day), "100"(count) ...

97/06/02
	$REJECT_ADDR_LIST ("$DIR/spammers")
	reject するアドレス From: と UNIX FROM に対して適用される。
	デフォルトの $REJECT_ADDR はこれとは別に適用される。

	%ProcedureException

	doc/smm, doc/ri a little improved

97/05/18
	$NOT_USE_SPOOL = 1; ＃DISKが足りない等で記事をためずに配送するだけ
	すべてのメンバーリスト等の操作で $FILE_TO_REGIST の値を考慮する

97/05/17
	snapshot package 再編成
	bin/fwix ".url" 命令

97/05/16
	preparation for fml-2.1-release
	snapshot , snapshot generator の再編成
	makefml 以外の installer を削除
	directory の整理、contrib の再編成

	makefml install とかちゃんとできるのは確認してるけどなんか勘違
	してたらめんご

97/05/12
	cf/config search_prog enhancemnet to handle options

97/05/11
	&DEFINE_MODE("mode_definition=type")
	oboslete; --[a-z] mode definition
	cf/config search_prog fixed to search plural candidates (anyway fixed)
	doc/smm	

97/05/07
	Gecos field (macro:x); overwritten is fixed
	etc/makefml/Makefile (config.ph -> config.ph.old)

97/05/06
	delete $NON_PORTABILITY (smtp, makefml)
	makefml FYI

97/05/01
	makefml: auto configure $STRUCT_SOCKADDR (cf も対応してmodify)
	import bin/multipart.pl v1.01 
	(thanks to Yuao Tanigawa <yuao@infonia.or.jp>)

97/04/30
	GenInfo fix
	on mail2fax

97/04/29
	INSTALL update
	library unlink
	makefml jperl check
	bin/analize_mail_error.sh bin/analize_mail_error.pl
	imported contrib/localhack/kizu
	mode 内部表現

97/04/19
	sbin/makefml  ML のドキュメントの Language の選択
	help 等を distribution package 中では doc/ doc/drafts へ移動
	clean up

97/04/18
	fwix html mode mkdir(directyr, 755);

97/04/17
	$CPU_TYPE_MANUFACTURER_OS の導入 (set by config.guess)
	＃特にソラリス２の人ちゃんと動くか試してみてね♪
	RFC2045

97/04/16
	admin resend file address

97/04/14
	mode change bug fix

97/04/07
	upgrade help INSTALL 

97/04/04

97/04/03
	sbin/makefml: 	 permission conserved
	sbin/install.sh: chmod 755 libexec/* bin/* sbin/*

■ fml 2.1 gamma test (for the preparation of the 2.1 release)

97/03/31
	fmlserv を複数配送ファイル等に適応させる。
	$REJECT_ADDR に majordomo, listserv, listproc を入れる
	(against いたずら)

97/03/30
	libexec/fmlserv.pl fixed 
	 ＃(quick hack, 複数ファイルへの対応はまだ完全ではない)

	FIX TYPO $AUTO_REGISTRATION_DEFAULT_MODE

	add a lot of .. in doc/smm 
	   UPDATED: すべての user defined variable の記述

97/03/28
	Clean uping ... 		 
	複数のモード混在の mget での Constructor Destructor FIX
	e.g. Mime-* bug, uuencode and tar.gz ...

97/03/27
	bug fix: help が使えない _o_
	複数リスト対応のための initializeをしそこねているものの fix

97/03/26
	 ML のアドレスを変更して axion -> fml.org 以下に収容。

	@ACTIVE_LIST に設定された
	複数の配送リストファイルを配送に用いる。
	＃まとめ送りの場合も当然複数ファイル対応と
	＃ crosspost 以外は対応が終了しているはず

97/03/23
	自動登録ルーチン(appended)
	   $AUTO_REGISTRATION_HOOK
	   $AUTO_REGISTRATION_DEFAULT_MODE

	15.8	$AUTO_REGISTRATION_DEFAULT_MODE

	登録を

		アドレス $AUTO_REGISTRATION_DEFAULT_MODE

	の形で行う。fml の内部表現↑で設定する必要があるので注意して下さい。

	例: デフォルトを skip にする

		$AUTO_REGISTRATION_DEFAULT_MODE	= "s=1"; 

	    まとめ送りで３時間に一回 Multipart に設定。

		$AUTO_REGISTRATION_DEFAULT_MODE	= "m=3mp"; 

	15.9	$AUTO_REGISTRATION_HOOK

	$AUTO_REGISTRATION_HOOK = q#
	    $e{'GH:Reply-To:'} = $MAINTAINER;
	#;

	WELCOMEのメールの Reply-To: を管理者宛にする

97/03/22
	doc/smm/pager.wix
	uuencode filename fixed	
	clean up; self-defense the strange behaviour of local scope
	fmlserv "単体"の機能は which だけを使えるだけに機能を落とす。
		注:メタレベルで help とかは仮想的に fmlserv  ML の help
		そうではなく 全 ML にまたがるコマンドは which だけということ

97/03/21
	sbin/makefml install: fixed search .fml/system
	geturl.pl probe-failed-action fixed

97/03/20 (from 97/03/10)
	directory 構造 clean up
		lib/localhack -> lib/fml_R1_localhack 
		とし、fml 1.x 用の hack の例をこの階層下に集める

	fix subject of mget, ...
	mget の compilation mode の表示のON,OFF (msend.pl, mget) 
	複数配送リストα版（まだ半分だから使わないようにね）
	bin/geturl.pl bug fix
	cf/MANIFEST fix (DLA)
	makefml により confirmation モードの設定を可能にする
		confirmation は推奨です。

	geturl.pl cleaned up (+ update mode)

		他………

97/03/10
	$NOT_SHOW_DOCMODE mget とか msend のドキュメントの形式の説明を省く

97/03/08
	libexec/fmlserv でデフォルトでは lists コマンドを unable する。
	$FMLSERV_PERMIT_LISTS_COMMAND  = 1 で使えるようにする(default は０)
	Listserv 的なインターフェイスのデフォルトは lists コマンドをさせない
	というのはこれがいたずらに多用されるため。

	doc: info changes 調整 (info には 97/02 以降を収録)

97/03/07
	zcat code bug fix
	makefml: add the search path entry "/perl5/bin" for NT4
		 Summary Information bugs fixed e.g. MIME
		 clean up codes and bug-fix of output not-uniqueness 
	bin/Archive.pl bug fix and adjusted for the current config.ph

97/03/06
	Pararell Delivery using plufal HOSTS ($MCI_SMTP_HOSTS > 1)
	BUG FIX --distribute in $ML_MEMBER_CHECK=0;(with fmlserv)

97/03/03
	[confirmしながらの自動登録の場合]
	   confirm passwd が必要な場合でも
	   subscribe phase が来たら常にリセットしまた最初から初められる。
	それに伴い confirm ファイルを修正

97/03/02
	help ファイル renewal
	--moderated forwarded 形式へ

97/03/01
	libexec/fml_local.pl の中身の関数は 
		libkern.pl libsmtp.pl libsmtutils.pl libdebug.pl
	そのものにいれかえ。
	＃引数を必要にするようにしてしまいましたが、元に戻した_o_

	confirmしながらの自動登録の場合
		confirm reset 
	で総やりなおしできるようにした。それに伴い confirm ファイルを修正

97/02/28

97/02/27
	msend Reply-To evaluation order fixed 
		(config.ph shoule be able to overwrite)
	whois backup fixed
	modereated mode fixed
	confirm ファイルを修正

97/02/25
	msend Reply-To
	fixed around perl version

97/02/18
	NT 向けドキュメントを少し書く
	tar zxvf fixed
	perl path fixing
	makefml lock problem(first time) fixed

97/02/16
	makefml setgid code added (for OS's NOT 4.4BSD)
	confirmation mode fixed 運用テスト(axion.phys.titech.ac.jp ML群)

97/02/15
	makefml config の配送モード設定, bug-fix, 
		flock, not-flock code fixed
		etc/makefml/cf fixed
	include-ctl fixed
	--ctladdr を追加。--distribute --ctladdr の時は ctladdr 優先にする
	よって、ML を config.ph で distributeモードにして
	アドレス ML-ctl を --ctladdr (include-ctl に書いてある)で呼べば
	コマンドを実行する。

97/02/14
	dup fix and check codes

97/02/11
	まとめ送りの時の Subject, X-ML-Name 修正
	Makefile のデフォルトを makefml を使うように修正(documentもともに)
	Debug 用 Emulation コマンド (bin/emumail.pl)

	モード：
	--stdinlog
	   その日のすべてのメールを var/log/STDIN_LOG_19970212 にログをとる
	   ＃ var/log/STDIN_LOG_日付 ごと (PIRC のようですな(謎))

	--distorctl
	   100%の保証はないが、control-address 宛を推測して、
	    ML 	    宛は配送だけ
	    ML -Ctl 宛はコマンド
	を実行するようにする
	（そのために include include-ctl がデフォルトで生成されるの
	で普通はそれを使うって下さい）

	--mimedecodedsubject
	   SubjectがMIME -> append "X-Subject: MIME-Decoded Subject"

97/02/10
	まとめ送り解除時の溜っている分の配送 bug FIXED
	関連場所への event scheduler code の配置(第２段階)
	HTMLに変換された場合 duplicated することがある bug FIXED

97/02/02
	CFによるリレー GW NGW DOM 対応
	bin/weekend-msend.sh (週一まとめ送り用)

97/02/01
	自動登録の confirmation モード ベータテスト
	   ＊説明：subscribe リクエストに対し一度確認を促す。

      ・RFC821 syntax relay (% relay hack is obsolete)
      ・get コマンドの拡張
	"get 数字" は今までどおりの Resend スタイル
	"get それ以外" は MIME/Multipart で送り返す。
		例えば "get last:3" は "mget last:3 mp " と同じ。 
	”mget …” コマンドは今までどおりに tar.gz がデフォルトの形式
	まとめてごそっというときには固まっている方が良い場合は mget 
	単に最近の数通をまとめてぱっと読みたい時などには get を使うと良い。 

	cf/MANIFEST	$CONFIRMATION_FILE (confirmation mode の説明)

97/01/31
	fixed to adjust qmail 0.96
	まとめ送りのSubject:のデフォルト Matome Okuri (Digest Delivery)
	doc/ に見本 welcome confirm (自動登録のConfirmation mode 用)
	makekfml:	include-ctl を追加, 
			libmakefml.pl を使わずに済むように変更。 
			libmakefml.pl は使わないけど backward-compat のため残す

97/01/30
	Rcsid

97/01/29
	loop check bug fix
	makefml fix (name space evaluation bug (perl -cw is a lie))
	makefml and $BRACKET problem (fix the source "cf" file) 

97/01/28
	まとめ送り（digest） の To: を (delivery list is suppressed)にする
	Confirm Mode 実装（アルファテスト）

97/01/27
	several bug fixes (fml-support:2056-2058あたり)

97/01/20
	Relay Hack Extension using CF style(by motonori@wide.ad.jp)
	for なぞの "Project" :-)
	Crosspost bug fix

97/01/19
	fmlserv のコードの整理
	コードの整理 (Append2, Write2)

97/01/18
	fml.pl のデフォルトに $USE_FLOCK = 1; を加える(config.ph評価前)。
	compat code に頼りきりの場合に flock() を使わないケースがあり得る。

	makefml の permission 制御のため、personal/group/fmlserv に拡張
		perlsonal そのマシンで ML を運用するのは一人だけ
		group 	  そのマシンで ML を運用する人が複数いる場合
		fmlserv	  そのマシンで ML を運用する人が複数いて
			  なおかつfmlservを使う場合

	$USE_FML_WITH_FMLSERV  
	複数のML運用者がいて fmlserv を使う場合は group permission で
	アクセス制限する必要があるので、そのためのオプション
	fmlserv を使う場合でも、そのマシンには自分の管理する ML のみ！
	ならこのオプションは使うべきではない。
	＃なお、fmlserv directory が同じ階層にある場合は自動的に設定される。

	HTML 化された記事の置き場所のデフォルトを var/htdocs から htdocs へ
	＃ permission の問題からそうでないとまずい 

	fmlserv (listserv-like interface) unsubscribe code 
	is fixed (when no member check)

97/01/15
	makefml の extention and fixes (に応じてINSTALLドキュメントも改訂)
	エラーの Warning 情報のメールの宛先のチェック Routine のbug fix _o_

97/01/14
	libexec/popfml.pl (libpop.pl)
	   popを使って ML をするための正式実装版ベータテスト２
	bin/pop2recv.pl を obsolete にして popfml.pl をその後継とする。

97/01/13,14
	エラーの Warning 情報のメールの宛先のチェックをする
	＃subscribe はもともとしてるんだが…

97/01/12
	libexec/popfml.pl (libpop.pl)
	   popを使って ML をするための正式実装版ベータテスト

97/01/11
	chdir -> cd (shell もの)
	NetBSD /bin/sh defines "cd chdir" as "cdcmd"
	しかし定義してないＯＳもある および bash は持ってない

	0でパディングをしない Count (e.g. Subject につく部分)
		$SUBJECT_FORM_LONG_ID = -1;
		$HML_FORM_LONG_ID = -1;

	doc/html の index.html を変更

97/01/10
	Copyright Updated
	bin/fwix.pl ２か国語化
	cf/config fixed for perl5
	proc/librfc1153.pl 年末年始FIX
	doc/smm 以外のドキュメントの２か国語化（ベータ版）
	Event管理機構(scheduler) (fml.pl libkern.pl)
	＃注意：↑ Windows NT 版では使えません。

96/12/25
	randomness fixed
	doc/INSTALL_on_NT4

96/12/24
	GenerateHeader() Header Fields Format (liblop.pl)

96/12/23
	liblop libsmtuitl
	conserve the header information in "get" command;

96/12/22
	fml_local.pl
	依存関係が複雑なので fml_local の独立性を解除し、
	通常の include 関係をたどることにする。そのため以前のように独
	立しては動かない。
	@INC のどこかに fml ライブラリが入っていることが必要

	NT用のDirectory 
		ftp://ftp.iij.ad.jp/pub/IIJ/dist/fukachan/ntfml/ 
	を作る。

	src/arch 	Architecture dependence "fml library" codes
	sys/arch	Architecture dependence codes
	をインストールするように変更。

96/12/21
	NT4.0への Porting 実験。アルファ運用テスト中
	＃ようするにすでに動いてるわけだ:-)

96/12/18
	perl makefml passwd 
	perl makefml fmlserv は listserv (or Majordomo)的インターフェ
	イスをセットアップします。
	機能はしますが、
	別のソフトウエアのDirectoryをそのまま使ってCompatかどうかはテスト段階

96/12/17
	@HdrFieldsOrder = (..., Date, Posted, ...);
	etc/makefml
	sbin/install.sh installing libexec

96/12/16
	permission 問題のため

	perl makefml 
		/usr/local/fml
		/var/spool/ml
		/var/spool/ml/etc/ML/samples
		/var/spool/ml/etc/crontab/user

	のような階層に変更

	perl makefml addadmin
	perl makefml byeadmin

	get コマンドのデフォルトを Resent-つきのフォワードに変更
	コマンドの結果だと分かるように
	Subject: に Get Number $ML_FN が付け加えられる他はスプールの
	元記事が送り返される。

96/12/15
	SMTP もしSMTPを張れない時は、sendmail -bs モードをtryする。

	perl makefml config ml
		メンバーチェック or 自動登録
		Subject のタイプ
		オプションの設定

	自動登録時に ML に流れるメールのReply-TOが CtlAddrになっている
	のを MAIL_LIST にFIXED

96/12/14
	bin/fwix.pl	2か国語対応
	ドキュメント英語翻訳プロジェクトスタート

96/12/13
	liblop.pl	summary option BUG FIXED

96/12/11
	scope of libfml.pl
	makefml:
	   fix fethcing symbole table statement for perl 5;

	makefml config ML
		簡単にするためにエントリは増やすべきではないが
		自動登録とSubject形式の設定項目だけは付け加える

	libexec/fmlserv.pl:
	   fix fethcing symbole table statement for perl 5;

96/12/10
	perl makefml の設定の保存場所の選択
		ソースファイル上で実行しない場合等の bug fixes

96/12/9
	perl makefml によるインストール方式
	まとめ送り や fml.c のサンプルも作成する

	各 ML のサンプルは ~/.fml/ML名/ の下に保存される

96/12/8
	perl makefml によるインストール方式

		perl makefml でインストール
		perl makefml newml 

	で ML の作成等の初心者向けインターフェイスの実装

	bin/spool2html.pl もスレッド処理をデフォルトに加える。

96/12/6
	$REPORT_HEADER_CONFIG_HOOK
	レポート、警告等のメールのヘッダ生成の直前
	このヘッダでは $le{'GH:From:'} の形なので、これをいじるとよい

	例：
	$REPORT_HEADER_CONFIG_HOOK = q#
	    $le{'GH:Sender:'} = "elena\@axion.phys.titech.ac.jp";
	#;

	libra.pl ls-lR コマンド FIXED

96/12/5
	hml タイプ Subject での Re: 問題の bug fix (fml.pl)
	$ACTIVE_LIST でのコメントの bug fix (libdist.pl)
	RFC1153 ルーチン内の parameter 渡しの bug fix (librfc1153.pl)

	自動登録ルーチン内部をより奇麗に(抽象化の度合いというべきか) 
							(libamctl.pl)

96/11/30
	%RELAY_SERVER

96/11/26
	--html (&DEFINE_MODE('html'))では スレッドも作るのがデフォルト
	libsynchtml.pl の bug fix 
		e.g. 1 - 99, SUN-SAT

96/11/23
	スレッド化 HTML (libsynchtml.pl) (Beta Test)

96/11/23
	スレッド化 HTML (libsynchtml.pl) (Alpha Test)
	$HTML_THREAD = 1; にするとスレッド化したindex.html として
	thread.html を作ります。
	両方を作るので好きな階層を見ればいいでしょう。
	スレッドには In-Reply-To: References: の依存関係を使っています。

96/11/22
	Snapshot source name is now 
		"fml-x.y{ALPHA,BETA,GAMMA}-snapshot\d+.tar.gz" FORM anyway...

	cf/config fixed to conserve the changes between users'cf and MANIFEST
	cf/compat.ignore require *LIMIT variables, FIXED;

96/11/17
	Aucea (AUtomatic CErtification and Alert system)
	to replace Elena and Fred (Aref v0)

96/11/12
	libsmtp.pl modified for qmail
	＃sendmail は柔軟なので昔から大丈夫だけどRFCにばか正なおすぎるの
	＃も困ったちゃんね

	libsynchtml.pl: representation of the boundary is fixed 

96/11/4
	libsmtp.pl style changed around SMTP CONNECTION

96/11/3
	Open() for "READ OPEN";
	libsmtputils.pl BUG FIXED

96/11/2
	$NOT_USE_CC （削除）; &DELETE_FIELD('Cc') を使って下さい。

	&DELETE_FIELD と &ADD_FIELD マクロ (for config.ph)
	例：
		&DELETE_FIELD('Errors-To');
		&ADD_FIELD('Errors-To');

	libsynchtml.pl
		$HTML_INDEX_UNIT:  day 以外も week と month に対応
		作るファイルの<TITLE>等の表示を少し変更

	bin/daily.pl -f etc/daily.ignore
		エラーやwarningの類と思われるもののみを表示する
		毎朝走らせてメールで受け取ると良いだろう

96/11/1
	DLA_HACK (Direct List Access) to use smaller stack

96/10/31
	cf/config modified 
		デフォルトの値がないように設定する変数は
		コメントアウトの形でOUTPUTするようにする。

	Subject: FORMAT modified when SUBJECT_*_FORM set;

96/10/30
	fix @HdrFieldsOrder to avoid duplicated Subject:

96/10/29
	FIX EacyConfigure's advanced setting
	sbin/configure_ph -> sbin/configure_advanced

96/10/28
	bin/spool2html.pl: HTTP_INDEX_UNIT -> HTML_INDEX_UNIT
	fml.pl:	Subject: and STRIP_BRACKETS and $SUBJECT*_FORM

96/10/27
	libdist.pl: distribution library extracted from fml.pl
		the main part of &Distribute;

96/10/26
	Makefile modified for the bug of NEXT;_;
	doc/smm/

96/10/23
	msend.pl: skip compatible mode compatible
	liblml -> libamctl (Active_list and Member_list ConTroL)

96/10/22
	msend.pl: fix TYPO: the lack of skip field exception code _o_

96/10/21
	libfml.pl, libutils.pl から分離
		liblop.pl	List and Log OPeraions
		liblm.pl	List Modifier

96/10/20
	doc/smm

	fml.pl
		var/run/msgidcache (<- var/log/msgid.cache)
		$TIMEOUT -> $FLOCK_TIMEOUT

	liblibrary.pl
	 FIXED: get の複数リクエストの制御
		$USE_LIBMIME -> $USE_MIME;

96/10/19
	check ne.jp address too within the 4 level of the address severly

96/10/14
	change declarations around while loop for more effeciency
	fml.pl msend.pl

96/10/13
	snapshot directory hierarchy: move *.pl src/*.pl
	fix (doc/smm) documents to follow the movement
	fix (SMTP's) local(%e) in the scope called from lib*pl
	    since perl5 local(%e) hides %Envelope (libsmtp.pl)
	SecureP() can permit [rms]=[\w\d]+ (fml.pl)

96/10/12
	fix %AdminProcedure for "admin passwd"
	Arrange a lot of Global Variables definitions of scripts 
		and doc/smm references
	fix hidden-password in a replied message
	fix AutoRegist() since dup check $MEMBER_LIST not $file_to_regist

96/10/11
	fix libra.pl, libfml.pl ta lot o fix "admin matome addr option" syntax
	fix help-admin

■ fml 2.0 current (version 2 pre release version) 

96/07/13

libutils.pl
	defauilt subscribe のなおしそこないをFIX
	自動 html 化ライブラリが一月;-)ずれてるのをFIX

96/07/12

お手軽インストールのバグをなおす;_;

	・こないだなおし過ぎて勢い余ってしまっているところ;_;

	% make MAIL_LIST=作りたいMLのアドレス MAINTAINER=ML管理者のアドレス

	MAINTAINER=ML管理者のアドレス	がちゃんと反映されてない
	＃ cf/config を使ってFIX処理を行うように変更

html mode definition
	default を 日毎に別の directory に保存するのを デフォルトへ
	＃前にしたつもりだったんだが…なおしそこねてた

libsubjectdef.pl
	subject フォームの見本
	e.g. 
		[Elena:100]
		[Elena 100]
		(Elena 100)
	あとどういうのがあるかな…

mode setting in &LoadConfig 
	コマンドラインとconfig.ph の間の compatibility のために必要

fix 
	chaddr がモード保存してないけど…一応するように
	＃環境ちがうんだから リセット するものだとはおもうのだが…

	chaddr a b with conserving the a's option e.g. m=..  s=..

perl5.002 の話

    local($returnfile)	 = "${TMP_DIR}/m:${opt}:${$}return";
    perl5 だとまずい部分のFIX

	libsendfile, libsmtp 

起動時に DNS ひいて $j $m $w あたりを推測する
config.ph に書いてある内容は有効だが、cache はやめた↓。

fml-support:00817
>普段使う部分のprofile強化月間：で、 可能なマクロは config.ph 
>に cache します。overwrite したいときは、しちゃって:-)
>
>例：	
>$Envelope{'macro:m'}	= 'phys.titech.ac.jp';
>$Envelope{'macro:s'}	= 'axion.phys.titech.ac.jp';
>$Envelope{'macro:ca'}	= 'pollyanna';
>$Envelope{'macro:fqca'}	= 'pollyanna@axion.phys.titech.ac.jp';

ここまでは 96/07/05 以降の  update 情報です↑

この↓期間の情報は fml-support ML にはあるのですが…
こっちに書く暇がない そのうち書きます _o_

----------------------

この2カ月くらい このファイルに反映されてません _o_ #暇なし
fml-support ML には情報を投げていますけど…

04/25

libexec/fml_local.pl
	SECURE_FML_LOCAL

fml.pl
	FIX the behaviour when $USE_SUBJECT_AS_COMMANDS is ON

04/24

	$EXPIRE_SUMMARY を non-nil にすると summary も Expire する

04/23

fml.pl
	&CheckMember は 特殊文字を含む場合、正規表現エラーを避けるため 
	high performance 用コードを用いない

libexpire.pl
	summary の expire も行う。

04/22

libfop.pl
libutils.pl
	FIX uuencode: bad file descriptor on NetBSD 1.1B

librfc1153.pl
	カスタマイズ用の変数を外へ出す（config.phで設定できるように）

	変数				デフォルト
	$RFC1153_ISSUE    		1
	$RFC1153_LISTNAME 		UJA
	$RFC1153_VOL      		$year
	$RFC1153_SEQUENCE_FILE  	$FP_VARLOG_DIR/IssueSeq

libsendfile.pl
     $MGET_TEXT_MODE_DEFAULT 
     $MGET_BIN_MODE_DEFAULT 
	mget のデフォルトの変更

msend.pl
     $MSEND_MODE_DEFAULT 
	まとめ送りのデフォルトの変更

＊＊＊＊＊
	SAPPORO.IIJ.AD.JP へ
	ターゲットマシンは perl 4.036 on NetBSD 1.1B へ
＊＊＊＊＊

@HOSTS			複数のsendmailの走っているマシン（非常時のセカンダリも含む）
$MCI_SMTP_HOSTS = N;	@HOSTS のうち Ｎ個 のマシンのsendmail をパラレルに使って
			（理論上での限界は）Ｎ倍配送を高速化する。
			Ｎは理論上 int と同じだろうが、普通は netmask できまるわな（笑）
			でも、他のドメインでも使えるから、int までいく（理屈、理屈）
			＃とくに actives の最後の方の人はうれしい

		ばぐ： actives の中をちゃんと考えてならべないと sendmail R8 の 
			HOST_CACHE がうまくいかせない可能性あり

bin/fwix.pl
	html 形式をサポート
	今度は var/html/op/ の下に index.html と Chapeter ごとのhtml をつくる

bin/split_and_msend.pl 
	unix from のかたちの file の まとめ送り 
	ようするに obsolute の まとめ送りＲ１ の現代版（苦笑）
	PLAIN TEXT ONLY っすけど。

・ lha して uuencode する モード

・FIX libra.pl help, log
・FIX libfml.pl approve 

・ &daemon  (libutils.pl)
   は、今のプロセスをデーモンにします。
   ＃4.4BSDのdaemon()には引数がありますが、まだそれをEmulateしていません

   cron.pl を動かすんなら、これをつかうべきでは？
   ＃でも、４．３ＢＳＤでしか動作確認してないけど…

例：
$FML_EXIT_HOOK = q#
	&use('utils');
	&daemon;
	exec("$LIBDIR/bin/cron.pl $DIR -a");
#;

・ file operations は libfop.pl へ

・ # library  コマンド	（liblibrary.pl）
   put も使える 別のちょっとちがう アーカイブ操作形式

・ whois iam who コマンドを復活させました。
   hmlと実装方式は全く別ですが:-)

拡張として whois -h ほすと指定 ってのができます

# whois [-h host] key	whois で key を探す。
			host が与えられた場合はそのhostへIPCで、
			もしそうでない場合は
			 ML ローカルな whois database を探します

# iam			自己紹介を登録する
# who			自己紹介の一覧を得る
# whois-index			同上
# whois-list			同上

・ traffic コマンド  を標準化（？）へ
作：谷川 百明生 さん  tanigawa@tribo.mech.nitech.ac.jp 

   [libtraffic.pl の説明]

     メイルの投稿量の統計をとるコマンドです。

   # traffic [-n <best?>] [-m <mails>] [-d]

   1. 月毎のメイル投稿量
   2. メイル投稿量毎の日数
   3. 時間帯別の投稿量
   4. １日２５通以上投稿があった日
   5. 投稿者ベストテン
   6. １日当たりの平均投稿量と最大投稿量

   を出力します。

     オプションで、-d を指定すると、さらに、

   0. 日毎の投稿量

   も得られます。デフォルトでは表示しません。

     オプション -n は、5.の投稿量の多い人のベスト何人まで表示するかを
   数字で指定します。デフォルトでは、-n 10 と同じです。

     オプション -m は、4.の何通以上あった日を表示するかを数字で指定し
   ます。デフォルトでは、-m 25 と同じです。

・  尋常でないアドレスからのメールははじく
    From: が 'root|postmaster|MAILER-DAEMON|msgs|nobody|news'
    のどれかの場合 管理者へメールをフォワードして サーバは何もしない
    下手に相手に何かを返すとピンポンするかも知れないので管理者に判断は任す

    上記以外のアドレスを追加したい場合、そのアドレスを 
	$REJECT_ADDR = "|nobody|nazo-no-hito";
   のように書くと追加できる。

・ libsendfile.pl SendFile.plが旧名称

・ bin/cron.pl は 実行したらcrontab の持ち主にメールをだす （４．４）
   ４．３のようにするには $CRON_NOTIFY をオフにするか
   cron.pl DIR -b43 のように起動する 

・ libsmtp.pl  ファイルを JIS へ 自動変換（jcode.plがないときはエラーだが）

・ libutils.pl ish+lzh mode bug fix

・libref.pl  	（libexec/sid.pl の標準装備）

URL を理解するための ライブラリ
http://host/something や gopher://host/something は自力で取りにいって、
必要なら、binaryをuuencode や、ファイル分割をして送り返す。
ftp://host/something は libftp.pl へ引き渡します。 

・libftp.pl   	（libexec/sid.pl の標準装備）
ftpmail server ($FTPMAIL_SERVER を設定していないとエラー) へのリレー
するインターフェイス（ＯＫ）
	と
local spool への ftp interface 

・fml_local は分割してファイルを送り返す関数をBuilt-IN しました。
＃ libutils.pl を使うので、INCLUDE-PATH を設定する必要があります

○Backward Compatibility:
	$COMPAT_FML15 = 1; 

＊＊＊ヴァージョンアップの場合の注意＊＊＊

基本的なデータ構造を call by reference 用に書きなおしたので、

libcompat.pl にBackward compatibility のためのコードがあります。
昔の設定を変えたくないなら、config.ph に $COMPAT_FML15 = 1; とかくとあ
る程度まで compatible にできます。
＃コードの都合上実現できないカスタマイズもありえます_o_

FAQ は新しい形で書きなおされています。

e.g.	Playing_to
	STAR_TREK_FORM
  ＊Replyt_to とかへの特別の操作を フックでやってたりすると要注意です＊
＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊

・ bin/inc_via_pop.pl を経由して、fml.pl を動かすことで、
   SMTPをうけつけないマシンで  ML  をつくるとか
   SMTPをうけつけないマシンで .forward に相当することをやるとか
   つまり、bin/inc_via_pop.pl から fml_local.pl をよべばＯＫ

   たぶん WINDOWS NT でもうごくはずなんだけど… （実験中）

・TYPO-FIX: $USE_SUBJECT_AS_COMMANDS が正しい、$USE_SUBECT_AS_COMMANDS 
	じゃなくて

・ bin/inc_via_pop.pl 
	bin/inc_via_pop.pl -host $HOST
		は	
	/usr/local/mh/inc -noaudit -norpop -noapop -host $HOST
	と同じ（はず）です。

・ %SEVERE_ADDR_CHECK_DOMAINS

%SEVERE_ADDR_CHECK_DOMAINS = (
			      'iijnet.or.jp', 1,
			      'bekkoame.or.jp', 1,
			      'rim.or.jp', 1,
			      'win.or.jp', 1,
			      );

インターネット・プロバイダーでは 
	USERNAME@ppp.DOMAIN 
	USERNAME@MACHINE.DOMAIN 
で、jpから３階層だけチェックしたのでは充分ではない場合がある。
例：
			      'iijnet.or.jp', 1,
この連想配列は
	username@.*.iijnet.or.jp にマッチしたら
	$ADDR_MAX_CHECK を１あげる。

これの応用として、デフォルトを厳しくして、特定のドメインでは -1 する。
ってのもありですね。

・コマンドでは $TRAILER_MAILBODY 等へのインフォがデフォルトでつきます。

・コマンドを実行したメールを送り返すとき
	$PREAMBLE_MAILBODY	（前）
	$TRAILER_MAILBODY	（後）
  を本文の前後に必ず付けます。
もし、なんらかの理由で普通のメールの場合にも付けたいなら
＃それは、人の郵便をかってに開けて、人の手紙に手を加えるようなもので、
＃倫理的に許されないと思うが…世の中いろいろあるだろう〜？？？

・index コマンド
# index			get できうるファイルのリストをかえす
			index ファイルがあるのなら、それを返します

＃SID で使うんです。これ

・SID を正式に標準化する。以下の場所へファイルの移動をしました。
	libexec/sid.pl
	etc/sid.ph
	etc/sidrc
	etc/help.sid

・admin と approve コマンドで password を要求するなら
$REMOTE_ADMINISTRATION_REQUIRE_PASSWORD = 1; 
				# require password when use commands above

REMOTE_AUTH (TYPO で REMORE_AUTH) が古い変数名。
バスワードコンパチにしてあるので、どっちの変数でもいいんですけど

・ lib/SID/sid.pl

Listserv-like INTERFACE for libfml.pl and libremote.pl

＊＊＊＊＊＊要注意＊＊＊＊＊＊
・$REMOTE_ADMINISTRATION 

リモート管理する部分を 正式なコードの一部に変更して、この変数で切り替
えるようにしたので いままで eval で使ってた人 この変数をセットしてくだ
さい _o_
＊＊＊＊＊＊＊＊＊＊＊＊＊＊＊

・$USE_SUBJECT_AS_COMMANDS = 1 ;

Subject: 行も コマンドとして使う。
例：
Subject; # mget 1-100 

・いかなる場合でも UNIX FROM なしのINPUTが来た時は、
  UNIX FROM をつける（補正）

・$PROHIBIT_COMMAND_FOR_STRANGER (<- $PROHIBIT_COMMAND_MODE)

＋エントリを使って誰にでも投稿可能にするときに 
	$PROHIBIT_COMMAND_FOR_STRANGER = 1; 
とすると、
「外部からは投稿可能＋自動登録なし＋メンバー以外はコマンドを使えない」
が実現できる。

□	libexec/fml_local.pl(独立して作動する)
~/.forward から使うためのインターフェイス  VER.2 
でも直接使うと、/usr/libexec/mail.local と同じに動く
＃でも結果論としてなんか slocal そのものみたいだな…ははは、うじゃ

slocalと違うのは、制御するファイルのFieldの数とか、正規表現が使えると
か、（必要なら fml のlibrary を呼び込んで）perlの関数を直接呼べるとか…
という upper compatibility です。

例：
＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿
# /usr/libexec/mail.local
From            fukachan        &       MailLocal
X-MLserver      fml             &       MailLocal
X-MLserver      SendFile        &       MailLocal
X-MLserver      MSendv4         &       MailLocal

# MH folders
From            fukachan@phys   |       /usr/local/lib/mh/rcvstore +inbox
To              Enterprise@phys |       /usr/local/lib/mh/rcvstore +enterprise

# File Retrieving
Subject         get\s+(\S+)     |       /usr/bin/Mail -s $F1 $From_address

# Exec ML
to              (uja)           |       $DIR/fml.pl $DIR $DIR
＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿＿

・ＯＳの違いによるソケットまわりのエラー
libsmtp.pl にその補正機構はbuilt-inされました。
→ 結果として sys/socket.ph へのリンクをはずす。

・EasyConfigure bug fix（thanks to sengoku@intsys.co.jp）

・ソラリス２．ｘでのソケット対策
（configure で 自動的に config.ph に $COMPAT_SOLARIS2 という変数がセッ
トされるはずですが）
	$COMPAT_SOLARIS2 = 1;
とセットして下さい。
うまくシステムのsys/socket.phが呼べないときに必要な定義をします。

・bin/vipw.pl	
	config.ph の edit 用
	ヴァージョンアップの時のロックにも使えるね(^^)

・UNDERWAY (for 1.5 -> 1.6)
fml.pl へ Notification してメールをユーザーへ返す関数を移す。
libfml.pl のstatus report は↑をつかう。
~/.forward extension fixes

コマンドは user define ができるように、
まとめ送りと同様に 連想配列で設定できるようにした。
これにより、簡単にコマンドの名前等の変更もできる。

whois で sub ipc がうごかないのをＦＩＸ

おまけ： bin/geturl.pl
% bin/geturl.pl URL 
で URL の中身をとってくる（TEXTいがいはしらないよん;-) ）

RFC934 ^- -> '- -' syntax conversion

1.5からの要注意： 

$MAINTAINER が ML-admin とか ML-request とかになっていないと

	WARNING: UNIX FROM Loop

が log にでます。
＃対策は -admin みたいにする、or そのチェック部分を削る
＃ →ＦＡＱのトラブルシューティングをみてね

bug fix 
ftpmailでuuencodeがうごかない（1.5直前から〜）

■変更点(diff between fml 1.5 and fml 1.4)

・newsyslog e.g. var/log/*.0 -> .1..

・UNIX FROM もループ CHECK

・summary コマンドの引数

・Makeのときに ＯＳの自動判別（して設定のアドヴァイスをする）

・EasyConfigure で config.ph の flock の設定まわりまで 対話的に行うス
クリプト

・Configure 廃止。新しい sbin/ccfml が cc への前段階処理をする

・スタートレックの 宇宙歴 がつく（笑）
＃ $APPEND_STARDATE = 1; in config.ph 

・EXPIRE 機能
・libSendBack.pl （あるアドレスに送ると ドキュメントとかを送り返すように
設定するための）

1.4.1 RELEASE 1995/5/7

・mget とまとめ送りでの User interface 
	PLAINTEST 
		UNIX FROM
		RFC934	
		RFC1153
		MIME/Multipart
	COMPRESSED FILE
		GZIP of UNIX FROM
		Lha + Ish 
		tar + gzip

を ユーザーごとに設定できる

ファイル構成を一部再構成（ like a 4.4BSD like ）
etc/crontab-4.3
etc/crontab-4.4
var/run
var/log
_smtplog -> var/log/_smtplog（本体）

■変更点(diff between fml 1.4 and fml 1.3)
1.4 RELEASE	1995/04/26 11:59:02 GMT

・"# matome 0" の時に、いまたまっているメールを送り出します。

・RFC1521 

・From と 配送先が一致した時に、配送を止める フック

・sjis conversion is ish+lzh mode
^M ^Z もつける。

・extract from archive to expand as tmp/spool/201 ...
 for '# mget 201-210 ..' not using tmp/extract$$

・fix libsmtp for rfc821 4.5.2

・sub system

・複数のアドレスが登録がされている時、
  普通のユーザーにたいしては 一つにマッチするまで頑張る、
  だめならだめ
  ただし、リモートでの アドミンコマンドでは 複数マッチを許す。
  OFF 引数 等の 引数も許す。

・まとめ送りのヴァリエーション拡張その１

・コマンドの拡張
まとめ送りで、Ｎ時間おき（デフォルト）と Ｎ時に一日一回指定

# status [引数]
# stat   [引数]		現在の設定について知らせる（まとめ送りとかOFFとか）
			デフォルト（# stat(us)）は自分自身の状態
# mget last:10 		(mhだね) シンタックス
# exit 			コマンドの終わり
# end			コマンドの終わり
# quit			コマンドの終わり

・libfml.pl はエラー処理を一括しておこなう。そうしないと複数のコマンド
ミスそれぞれについて警告メールが返ってしまうから

・fml の remote control（admin command）のパスワード機構

・変数名等の変更：
PRE_HOOK -> START_HOOK
ExExec -> RunHooks
"# guide" は本当に知らない人の時だけ特別扱い

・ＦＡＱに索引がついたぞ！

・~/.forward で 使う方法

・ for $s in /etc/sendmail.cf

・ マスターコントロールサーバ (./lib/Master)
	www, ftp, wais, gopher とのＩＰＣの中継をする
	おまけ機能で 
	subscribe ML-address とか
	member ML-address とか
	which とか
	できる（あくまでおまけ）＃実は単にＩＰＣの中継してるだけ

・INSTALL MANUAL English 版:-)

・クロスポスト機能

・自動登録のときに reply-to を使わず。明示的に登録アドレスを変えるなら 
subscribe ml-address のようなキーワードを必要とするように

・$TMP_DIR

・明示的に $USE_WARNING をセット（e.g. $USE_WARNING = 1;）しない限りコ
マンドメールでの単なるシンタックスエラーの警告をしない
＃ヘルプを返さない。signuatureとかでひっかかるから

・ Proceess Table に ML 名をつける（８文字もありゃ十分だろう）

・古いライブラリ は lib/Compatibility に移動

・マシンによってはプロセス間通信がうまくいかない？
lib/Sendmail/libo2smtp.pl(旧 libR8.pl)

・MSendrc もしリアルタイム配送にきりかえたらちゃんとこっちのエントリも
消す

■変更点(diff between fml 1.3 and fml 1.2)

・まとめ送り ver.1-4
  ver. 3,4 ではUNIX FROM <-> RFC934 きりかえ等もオプショナルサポート

・より secure に

・標準の spool と Archive( tar + gzip ed files) spool
	およびget等でのアーカイブへのアクセス

・コマンドフック

・ドキュメント Generator(lib/AIKO) texinfo and html自動 Generator

・自動的に ML のspoolをhtml化する

・httpdへの（ＩＰＣ） smtp インターフェイス（というのか？）

・hml とはちがう任意の Whois サーバとのＩＰＣ

・コマンド操作の誤チェック機能

・明示的な自動登録をする（オプショナル）
	例：	Subject: subscribe
	本文に subscribe pollyanna@phys.titech.ac.jp 等

・自動登録で登録要請をしているメールは ML へ流さないモード（オプショナル）

・ユーザからのリモート制御 
	# matome 数字(0-23)	コマンド

・mget ver 2 
	# mget 1-3,4-100,100-1000 time のようなシンタックスも自動判別
	して動く

・lock algorithm toggle switching の非対象性をなくした

・gzip, zcat を使う

・hml 1.6にあったアドミンコマンド（remote で  ML サーバを操作する）
（オプショナル）

・new options of configuration files
	・ + in members
	・ skip in actives
	・ matome in actives（まとめ送り ver.2-4）

・RecreateConfig.pl	config.ph の自動更新

・ヘッダフィールドの形の保存

・サーバで予定していないヘッダフィールドも保存して活用（オプショナル）

・MIME decoding機能（オプショナル）

・hml 1.6 形の Subject field（オプショナル）
＃こんな形 → Subject: [Elena:ID] サブジェクト

・Documentsの改良。

・ひとつのfmlで複数の ML を扱う（２方式）（実は1.1.2.17からある）

■主な変更点(diff between fml 1.2 and hml 1.6)

・モジュール化
・コマンド群の分離（libfml.pl等）
＃必要な時だけrequire機能を使い組み込む。

・Configurationsはconfig.phで設定

・Contribでの補強。まとめ送り用コード等。詳しくは Contrib/README
・まとめ送り
・投票用サーバ
・その他のいろいろなコードの見本

・activesファイルで%式リレーを制御

・Makefile, Install Program, 

・対話式インストールプログラム EasyConfigure

・現在はC wrapperを使いMaintainerの uid,gidで実行するように設定（デフォー
ルトのインストールではそうなる）
＃hmlではsendmail -fのためだけに必要なdaemonを使うことの解消。（５．ｘ
の時代のはなし）

・よく見られるコマンドモードと配布モードの間違いを防ぐため最初の３行以
内に ^#.*$が現れたら自動的にコマンドモードとなり配布しない。
＃日本を前提にしたこの仕様は失敗かもしれない（つまり日本語のメールなら
最初の３行のどこかに＃があってもそれは＃であり#ではないだろうと仮定し
ている）。
＃”３行”は$COMMAND_CHECK_LIMIT = 3;で設定（see config.ph）

・sendmailとはsmtpポートでＩＰＣ（libsmtp.pl）sendmailコマンドを呼ぶの
ではなく、プロセス間通信でsendmailへ渡す。
＃IPCはちゃんとesmtpの場合でもうけとるように気を配る(for sendmail 8.x)

・ロック・アルゴリズムはflockとpidを使う２種類（fml.pl liblock.pl）

・Toggle flag configurations

・メンバーチェックをするか否か？（する＝１）
	「メンバーチェックをするサーバ」と
	「自動登録しながら走るサーバ」

・ロックはflockを使うか、PID式を使うか？（flock＝１）

・サーバーテスト用デバッグモード（debug mode = 1）

・コマンドの書き方について。# get 1 と #get 1は同じもの等。

・ｗｈｏｉｓ等実績のないコマンドの削除（libfml.pl）
＃使わんって（やりたいなら専用のをつかえばいいでしょう）

・ｍｇｅｔ（まとめてget :-)）…付け加えたコマンド（libfml.pl）
“# mget 正規表現 送り返されるメールの送り間隔”による大規模な過去のメー
ル取り寄せ機能送り返しはそれようのコマンドへ
＃ftpmailのようなもの。ＩＰの人だけならpasswdつきのanonymous ftp？:-) 
にする方がいいとおもう。

・（余計かもしれなくても）loggingはできるだけする
＃なんかあった時便利です。ごみごみするけどメリットはあるとおもう。

・リレーやＭＸについては FAQ ファイルを参照して下さい

# REFERENCES (please see doc/op.{jp,en})

Release Version 1.2.1

Message-ID: <FUKACHAN.94Apr10222414@exelion.phys.titech.ac.jp>
Message-ID: <FUKACHAN.94Apr10222520@exelion.phys.titech.ac.jp>

Subject: fml 1.2 Mailing List Server(upper compatible with hml1.6).  
Message-ID: <FUKACHAN.94Mar15165051@exelion.phys.titech.ac.jp>

Subject: hml1.6: a powerful mailing list server
Message-ID: <HIRANO.91May1105615@azabu.tkl.iis.u-tokyo.ac.jp>

$Id: CHANGES.wix,v 1.19.2.2 2001/07/01 03:37:30 fukachan Exp $
# Copyright (C) 1993-2000 Ken'ichi Fukamachi
#          All rights reserved. 
#               1993-1996 fukachan@phys.titech.ac.jp
#               1996-2000 fukachan@sapporo.iij.ad.jp
# 
# FML is free software; you can redistribute it and/or modify
# it under the terms of GNU General Public License.
# See the file COPYING for more details.
